---
layout: post
title: FIS 与 Grunt 的区别
author: walter
---

Grunt 是一个基于 task 的构建工具，依赖众多的插件进行配置组织，可以解决基本的前端自动化问题。FIS 是基于工具、开发框架、本地开发环境为一体的前端解决方案，不但拥有各类工具插件，同时还针对 PC、Mobile、I18n 等业务、场景总结了很多最佳实践。下面将对 FIS 与 Grunt 进行对比分析，让大家更好的了解 FIS。

![what is fis](/img/fis/what.png)

| Feature | Fis | Grunt | Comment |
| ------------ | ------------- | ------------ | ------------ |
| 自动化编译流程 | ✓  | ✓ | FIS 可自动构建文件编译流程，减少手动操作 |
| 前端编译工具 | ✓ | ✓ | FIS 拥有针对 JS、CSS、HTML、LESS、CoffeeScript、Smarty、前端模板等校验、合并、优化等工具，同时支持二次开发插件 |
| 前后端解耦 | ✓  | ✓ | FIS 并不关心你使用的任何前后端框架以及语言，甚至可更好的独立开发前端项目 |
| 最佳实践 | ✓  | ✗ | FIS 根据众多前端业务总结整理了适合各类场景的最佳实践方案，方面用户直接使用合理的前端方案|
| 模块化支持 | ✓  | ✓ | FIS 拥有 JS、CSS 以及模板级别的模块化方案 |
| 多平台多语言本地开发环境 | ✓  | ✓ | FIS 可在多平台下支持 JAVA、NODEJS、PHP 的本地服务器，拥有数据模拟、URL 转发等功能，支持前端项目本地开发预览调试 |
| 文件监听 | ✓  | ✓ | FIS 可监听文件的变化直接进行文件编译、浏览器刷新，方面用户本地开发预览调试 |
| 图片合并 | ✓  | ✓ | FIS 可根据整站进行图片合并，减少繁重的手动成本 |
| 自定义规范 | ✓  | ✗ | FIS 可根据不同的业务等制定开发及部署规范 |
| 静态资源管理 | ✓  | ✗ | FIS 根据静态资源表对整站的静态资源进行管理加载 |
| 多平台支持 | ✓  | ✓ | FIS 可在 win、Linux、mac 等系统下正常运行 |
| 自定义流程 | ✗  | ✓ | FIS 根据前端开发的经验自定义一套合理的编译流程，无需用户再自定义 |
| 部署配置 | ✓  | ✓ | FIS 可根据配置编译发布至本地或任何其他机器，方便用户联调等 |

