---
layout: post
title: 'FEX 技术周刊 - 2017/03/13'
author: hefangshi
tag: weekly
---

微信搜索『FEX』关注我们的公众号，及时获得最新资讯。

## 深阅读

**Polymer 2.0 Release Candidate is available and ready for use!**  
https://www.polymer-project.org/blog/2017-03-08-2-0-rc  
The new library is more modular than before, starting at just 10kb for Polymer.Element, the base class to extend elements from. We’ve squeezed out even more performance increases on native browsers, like Safari Tech Preview and Chrome. Polymer 2.0 remains focused on bringing development closer to the platform than ever before, leveraging the power of the browser to build performant, large-scale applications.

**WebAssembly: Under the hood with Mozilla**  
https://www.youtube.com/watch?v=o52_5qAJhNg  
Take a closer look at how WebAssembly works, how this relates to JavaScript, and how it was all developed. It all started with an experimental project at Mozilla by research engineer Alon Zakai to develop emscripten, and grew into asm.js with the help of Luke Wagner and Jukka Jylänki, and finally into a cross-browser collaboration on WebAssembly.  另附：[Previewing the WebAssembly Explorer](https://hacks.mozilla.org/2017/03/previewing-the-webassembly-explorer/)

**Welcome to the Grid**  
http://meyerweb.com/eric/thoughts/2017/03/07/welcome-to-the-grid/  
Grid is public.  It’s live right now in the latest Firefox release, Firefox 52. It will similarly be live in the next public Chrome release, due in the next week or so. 另附：[Firefox 52: Introducing Web Assembly, CSS Grid and the Grid Inspecto](https://hacks.mozilla.org/2017/03/firefox-52-introducing-web-assembly-css-grid-and-the-grid-inspector/)、[Webkit - CSS Grid Layout: A New Layout Module for the Web](https://webkit.org/blog/7434/css-grid-layout-a-new-layout-module-for-the-web/)、[Playing with CSS Grids](https://14islands.com/blog/2017/03/07/playing-with-CSS-grids/)、[CSS Grid: First Steps](http://jeffbridgforth.com/css-grid-first-steps/)

**The System Design Primer**  
https://github.com/donnemartin/system-design-primer  
Learning how to design scalable systems will help you become a better engineer. System design is a broad topic. There is a vast amount of resources scattered throughout the web on system design principles. This repo is an organized collection of resources to help you learn how to build systems at scale.

**SelfEncapsulation**  
https://martinfowler.com/bliki/SelfEncapsulation.html  
Self-encapsulation goes a step further, indicating that all internal access to a data field should also go through accessor methods as well. Only the accessor methods should touch the data value itself. If the data field isn't exposed to the outside, this will mean adding additional private accessors.

**Practical Design Discovery**  
https://alistapart.com/article/practical-design-discovery  
One of the hardest design problems I ever worked on was for a company that helps IT groups manage risk. Their product focused on open-source components—inexpensive and widely supported by an enormous community, but often vulnerable to security flaws.

**Analysing the use of outdated JavaScript libraries on the web**  
https://blog.acolyer.org/2017/03/07/thou-shalt-not-depend-on-me-analysing-the-use-of-outdated-javascript-libraries-on-the-web/  
In this paper, we conduct the first comprehensive study of client-side JavaScript library usage and the resulting security implications across the Web. Using data from over 133K websites, we show that 37% of them include at least one library with a known vulnerability; the time lag behind the newest release of a library is measured in the order of years.

**The Document Outline Dilemma**  
https://css-tricks.com/document-outline-dilemma/  
For the past few weeks there has been lots of talk about HTML headings in web standards circles. Perhaps you've seen some of the blog posts, tweets, and GitHub issue threads. Headings have been part of HTML since the very first websites at CERN, so it might be surprising to find them controversial 25 years later. I'm going to quickly summarize why they are still worth discussing, with plenty of links to other sources, before adding my own opinions to the mix.

**Create Offline Web Apps Using Service Workers & PouchDB**  
https://www.sitepoint.com/offline-web-apps-service-workers-pouchdb/  
In this post, we will look at how to add offline support to a basic contact list web app by implementing asset caching, client-side data storage and synchronization with a remote data store.

**You might not need a build tool**  
https://medium.com/@pakastin/you-might-not-need-a-build-tool-ac3c1a8cfaac#.292wkw23z  
Build tools come in all size and color. But do you really need them? Wouldn’t it be easier to just follow the original CLI documentation of Rollup, Stylus or whatever and call it a day? Not to mention they add up a lot of dependencies. I’m going to show you the “native” way with NPM scripts and chokidar.

**The 80/20 Guide to Async/Await in Node.js**  
http://thecodebarbarian.com/80-20-guide-to-async-await-in-node.js.html  
Arguably the biggest new feature in Node.js 7.6.0 is that the much awaited async function keyword is now available without a flag. Callback hell and promise hell are now in the past. But, like Uncle Ben always reminded us, with great power comes great responsibility, and async/await gives you a lot of new and exciting ways to shoot yourself in the foot. You still need to handle errors and be aware of the async nature of your code, otherwise you'll inevitably be complaining about "async/await hell" in 6 months.

**Reducing Slack’s memory footprint**  
https://slack.engineering/reducing-slacks-memory-footprint-4480fec7e8eb#.cucelx1xd    
降低后台页面的内存消耗

**Introducing Similarity Search at Flickr**  
http://code.flickr.net/2017/03/07/introducing-similarity-search-at-flickr/  
At Flickr, we understand that the value in our image corpus is only unlocked when our members can find photos and photographers that inspire them, so we strive to enable the discovery and appreciation of new photos.To further that effort, today we are introducing similarity search on Flickr.

**Netflix Downloads on Android**  
http://techblog.netflix.com/2017/03/downloads-on-android.html  
Netflix is now a global company, so we wanted to provide a viewing experience that was truly available everywhere even when the Internet is not working well. This led to these three prioritized download use cases: Better, uninterrupted videos on unreliable Internet; Reducing mobile data usage ;Watching Netflix without an Internet connection (e.g. on a train or plane).

**那些年，我们一起写过的“单例模式”**  
https://mp.weixin.qq.com/s/wEK3UcHjaHz1x-iXoW4_VQ  
结合我们的 Android 项目，谈谈大家在其中使用到的一些设计模式。一则，就个人的学习经验看来，研究例子是最容易学会设计模式的方式；二则，其实设计模式的应用同所使用的编程语言和环境都是有关系的，譬如说，我们最先要讨论的单例模式，在 Java 中实现的时候就要特别注意不同 JDK 版本对该模式造成的影响。

**浏览器亚像素渲染与小数位的取舍**  
https://isux.tencent.com/subpixel-rendering-and-percentage-calculations.html    
果然有人研究这个了

**Mobx 思想的实现原理**  
https://github.com/ascoders/blog/issues/16    
Mobx 中 autoRun 的源码分析

**卡通渲染-致从没看懂过着色器代码的你**  
https://zhuanlan.zhihu.com/p/25595069  
其实不仅仅是前端，图形渲染对于整个软件工程来说，都是一个很特定的研究领域。这就意味着，大部分情况下，你可能并没有那么迫切的需求去学习它。这也是为什么，WebGL 标准推出了那么多年，在前端的各种分享会上，即使介绍，也永远都是 Hello World。这一系列主要针对使用着色器实现不同效果的渲染算法作介绍。对图形有兴趣的同学可以关注这个专栏。

**腾讯游戏的运维服务是什么样的**  
http://mp.weixin.qq.com/s?__biz=MzA4Nzg5Nzc5OA==&mid=2651664891&idx=1&sn=68641b2afc904868e1f05fd9f3a23680  
运维服务的三个关键点抽象得挺不错的：用户关注；能够增值效益；可计价。另附：[译-一个Google SRE工程师眼中的8点运维原则](http://mp.weixin.qq.com/s?__biz=MzAwMDU1MTE1OQ==&mid=2653548334&idx=1&sn=b55a00d784cf073f6b8b2ea954dc7b22)

**I wanted to see how far I could push myself creatively. So I redesigned Instagram**  
https://medium.freecodecamp.com/i-wanted-to-see-how-far-i-could-push-myself-creatively-so-i-redesigned-instagram-1ff99f28fa8b#.1isyluuzv  
The challenge: to take an application I love and use everyday, then see how far I could push myself creatively as a designer, by rebuilding it from the ground up.

**Sketch Vs. Figma: The Showdown**  
https://www.smashingmagazine.com/2017/03/sketch-figma-showdown/  
The past year has seen quite a rise in UI design tools. While existing applications, such as Affinity Designer, Gravit and Sketch, have improved drastically, some new players have entered the field, such as Adobe XD (short for Adobe Experience Design) and Figma. In this article, I’d like to compare both apps in detail and highlight where each of them shines.

**What it feels like to be an open-source maintainer**  
https://nolanlawson.com/2017/03/05/what-it-feels-like-to-be-an-open-source-maintainer/  
Outside your door stands a line of a few hundred people. They are patiently waiting for you to answer their questions, complaints, pull requests, and feature requests. You want to help all of them, but for now you’re putting it off. Maybe you had a hard day at work, or you’re tired, or you’re just trying to enjoy a weekend with your family and friends.

**A Programmer’s Introduction to Unicode**  
http://reedbeta.com/blog/programmers-intro-to-unicode/  
I’m going to focus on the character set and what’s involved in working with strings and files of Unicode text. However, in this article I’m not going to talk about fonts, text layout/shaping/rendering, or localization in detail—those are separate issues, beyond my scope (and knowledge) here.

## 新鲜货

**关于苹果警告**  
http://blog.cnbang.net/internet/3374/  
iOS 开发者们陆续收到苹果邮件，警告去掉动态下发功能，覆盖面很广，内容没有明确指示是什么库，导致大家各种猜测。 其实上周已经有少量用户收到苹果这份警告邮件，当时还以为是特例，现在看来是在灰度测试扫描代码，可见这事苹果应该讨论已久，并专门排期开发测试了扫描程序，直到昨天才正式上线。从各方信息看起来，很不幸主要禁的还是 JSPatch / wax/ rollout 这样的热修复框架，特点是可以通过 JS 脚本调用和替换任意 OC 方法，而像 React Native/ 小程序这样用 JS 做功能的暂时不受影响，Weex 不确定，至于其他库像 AFNetworking / SDWebimage 用到那几个接口的，应该只是误伤。

**Introducing Cloud Functions for Firebase**  
https://firebase.googleblog.com/2017/03/introducing-cloud-functions-for-firebase.html  
Today we are excited to announce the beta launch of Cloud Functions for Firebase. It lets you write small pieces of JavaScript, deploy them to Google's Cloud infrastructure, and execute them in response to events from throughout the Firebase ecosystem. This has been the most requested feature since Firebase launched. The ability to extend and connect Firebase features using Cloud Functions makes Firebase more powerful, allowing you to do even more with your app without having to think about servers. 另附：[Google Cloud Platform: your Next home in the cloud](https://cloudplatform.googleblog.com/2017/03/Google-Cloud-Platform-your-Next-home-in-the-cloud.html)

**V8 引擎新架构 Ignition + TurboFan 即将正式启用**  
http://benediktmeurer.de/2017/03/01/v8-behind-the-scenes-february-edition/  
经过将近4年的不断开发升级，V8 引擎即将正式启用新的解释器 (Ignition) 与编译器 (TurboFan)，这项升级是 V8 近几年最大的升级之一，将为 realworld JavaScript 带来更大的性能提升，V8 引擎将会占用更小的内存，完成更多的性能优化。

**Bit**  
https://github.com/teambit/bit  
Bit is a distributed virtual component repository designed for easy use, maintenance and discovery of code components. With Bit, you can virtually create and model components on a distributed Scope, then discover and use these components to dynamically compose a virtual API with the components you actually use in your application. 使用介绍：[Managing Code Components with Bit](https://www.sitepoint.com/managing-code-components-bit/).

**Mditor**  
https://github.com/Houfeng/mditor  
Mditor 是一个简洁、易于集成、方便扩展、期望舒服的编写 markdown 的编辑器，支持浏览器: chrome/safari/firefox/ie9+

**Introduction to Web Audio API**  
https://css-tricks.com/introduction-web-audio-api/  
Web Audio API lets us make sound right in the browser. It makes your sites, apps, and games more fun and engaging. You can even build music-specific applications like drum machines and synthesizers. In this article, we'll learn about working with the Web Audio API by building some fun and simple projects.

**Wetland**  
https://github.com/SpoonX/wetland  
An ORM for Node.js written in typescript. Works with MySQL, PostgreSQL, SQLite and more.

**Service Worker Toolchain**  
https://github.com/pinterest/service-workers  
A collection of service worker generation tools. Configurable and forkable.

**hyperapp**  
https://github.com/hyperapp/hyperapp  
HyperApp is a JavaScript library for building frontend applications. Declarative: HyperApp's design is based on the Elm Architecture.
Stateless components: Build complex user interfaces from micro-components. Batteries-included: Out of the box, HyperApp has Elm-like state management and a virtual DOM engine, it still weighs 1kb and has no dependencies. HyperApp is not opinionated about your stack either; we're compatible with all bundlers and work well with Hyperx or JSX -- it's your choice.

**eslint-plugin-compat**  
https://github.com/amilajack/eslint-plugin-compat  
Lint the browser compatibility of your code

**iot-433mhz**  
https://github.com/roccomuso/iot-433mhz  
Iot-433mhz is a home automation framework for 433mhz devices that runs on node.js. You can control 433MHz RC power sockets, PIR sensors, Door Sensors and much more. To get started you just need a: 433mhz transmitter and receiver, both connected to an Arduino with the iot-433mhz sketch on it; A PC/RaspberryPi that runs the iot-433mhz platform, connected to Arduino through USB.

**"💩".length === 2**  
http://blog.jonnew.com/posts/poo-dot-length-equals-two  
Yup, it’s true. In Javascript, "💩".length === 2. You can open up a Chrome debug console, or Node.JS REPL and see for yourself. But why?! And why does '⛳'.length only equal 1?

**Developing a complete REST API with Loopback**  
https://blog.optis.be/developing-a-complete-rest-api-with-loopback-a3190edc105a#.8r87u8rmw  
Loopback was created as an open source mobile backend-as-a-service framework by Strongloop. It allows you to setup a REST API in minutes and is based on Express.

**The Rusty Web**  
https://davidmcneil.gitbooks.io/the-rusty-web/content/  
Welcome! This guide illustrates using the Rust programming language to target the web. The basic design pattern this project explores uses Rust to implement CPU bound portions of an app while using existing web technologies to handle user facing, I/O bound pieces.

**YC’s Online Class**  
https://blog.ycombinator.com/onlineclass/  
https://startupschool.org/  
Startup School is a free 10-week massively open online course (MOOC). The course will begin on April 5th, 2017. Lectures will be posted here weekly.

**New Features in C# 7.0**  
https://blogs.msdn.microsoft.com/dotnet/2017/03/09/new-features-in-c-7-0/  
C# 7.0 adds a number of new features and brings a focus on data consumption, code simplification and performance. Perhaps the biggest features are tuples, which make it easy to have multiple results, and pattern matching which simplifies code that is conditional on the shape of data. But there are many other features big and small. We hope that they all combine to make your code more efficient and clear, and you more happy and productive.

**游戏开发完整学习路线**  
http://www.cnblogs.com/majianchao/p/6523455.html  
在软件开发中，游戏开发这个方向看起来目标很明确，但其实是个领域很广的方向，入门的时候如果得不到指点一二，很容易误入歧途，相反，如果走这条路之前能得到前人的一些指路，是可以事半功倍的。

**PHP The Right Way 中文版本**  
http://laravel-china.github.io/php-the-right-way/  
目前网络上充斥着大量的过时资讯，让 PHP 新手误入歧途，并且传播着错误的实践以及不安全的代码。PHP 之道 收集了现有的 PHP 最佳实践、编码规范和权威学习指南，方便 PHP 开发者阅读和查找。 使用 PHP 沒有规范化的方式。本网站主要是向 PHP 新手介绍一些他们没有发现或者是太晚发现的主题， 或是经验丰富的专业人士已经实践已久的做法提供一些新想法。本网站也不会告诉您应该使用什么样的工具，而是提供多种选择的建议，并尽可能地说明方法及用法上的差异。

## 产品及其它

**How Slack Supports Junior Engineers**  
https://slack.engineering/how-slack-supports-junior-engineers-89f6dcfe74a1#.quxze6jdw  
In sharing my reflections on why I accepted my offer to work at Slack, the steps I’ve taken to optimize direct and indirect mentorship, abundant opportunities for impact and growth, and a culture of learning that Slack has kept remarkably intact at scale, I hope you will take away some useful insights for you and your team.

**知识正在成为商品 并以付费形式标准化**  
http://tech.qq.com/a/20170312/020609.htm  
知乎创始人周源分享知乎在尝试“知识付费”时所积累的经验和心得体会，知识付费最近非常的。相关文章：  
- [知识付费的几个坑罗胖们想好了么](https://www.huxiu.com/article/184534.html)
- [知识，互联网和钱-3](http://mp.weixin.qq.com/s?__biz=MzAxMzMzODcyNQ==&mid=2652478862&idx=1&sn=a9ab4c8ad026eea7903bdef9449f7e2b)、[知识，互联网和钱-2](http://mp.weixin.qq.com/s?__biz=MzAxMzMzODcyNQ==&mid=2652478836&idx=1&sn=e790f230e6ca9ee7c1a856f7b23e59ff)、[知识互联网和钱-1](http://mp.weixin.qq.com/s?__biz=MzAxMzMzODcyNQ==&mid=2652478831&idx=1&sn=1c5bb4528d8b1019db8089272085f0b9)
- [罗辑思维All-in“内容付费”背后的逻辑及我的思考](http://mp.weixin.qq.com/s?__biz=MjM5NDUyOTAwOA==&mid=2652915169&idx=1&sn=6581ad83ae21cbfbc2c9c4111eefa06c)
  
**别做口头上的学习者**  
http://mp.weixin.qq.com/s?__biz=MjM5ODQwMjA4MA==&mid=2649293773&idx=1&sn=349fc65c0954722d6e476ad7523bd308  
在这个时代，人人都标榜自己是学习者。有些人，真的是在不断学习，而有一些，通过购买各种课程，加入各种学习社群，给自己打上学习者的标签。后者，有一大部分是口头上的学习者。

**Playbook 中文版**  
https://beansmile-gitbook.gitbooks.io/playbook-cn/content/  
我们是 thoughtbot。我们和世界各地的上百个产品团队合作过，他们中既有自筹资金的个人创业者，也有庞大的跨国公司。我们也创建了自己的产品，同时有若干个开源项目。
这是我们的 playbook。它详细解释了我们是如何创建成功的 web 和移动产品，以及如何运营公司。书中充满了我们自身的经验以及研究其他团队的心得。Playbook字面上是一个体育术语，是一个球队的战术手册，它也非常形象地概括了本书的内容，它不是教条，而是一本鲜活的战术手册，他不仅可以用来学习，更适合用来指导实战。