---
layout: post
title: 'FEX 技术周刊 - 2017/11/13'
author: nwind
tag: weekly
---

微信搜索『FEX』关注我们的公众号，及时获得最新资讯。

## 深阅读

**V8 developers and their tools**  
https://v8project.blogspot.ca/2017/11/web-tooling-benchmark.html  
JavaScript performance has always been important to the V8 team, and in this post we would like to discuss a new JavaScript Web Tooling Benchmark that we have been using recently to identify and fix some performance bottlenecks in V8.

**Node.js Best Practices**  
https://github.com/i0natan/nodebestpractices  
The largest Node.JS best practices list. Curated from the top ranked articles and always updated. 另附：[The Front-End Checklist](https://codeburst.io/the-front-end-checklist-8b2292fdda44)

**Announcing DraftJS Plugins 2.0**  
https://medium.com/@nikgraf/announcing-draftjs-plugins-2-0-8c25f2a4df55  
2.0 ships with 9 new plugins and to get a better overview we categorised them into four different groups: Content Plugins, Atomic Block Plugins, Toolbar Plugins and Decorator Plugins.

**How we do Vue: one year later**  
https://about.gitlab.com/2017/11/09/gitlab-vue-one-year-later/  
It's been a while since [we wrote about Vue](https://about.gitlab.com/2016/10/20/why-we-chose-vue/). Since that last post,  we published [a very extensive Vue style guide](https://docs.gitlab.com/ee/development/fe_guide/vue.html), after which Vue also put out [a style guide](https://vuejs.org/v2/style-guide/), taking inspiration from ours. The style guide has been updated several times as we discover better ways to write Vue. Here are some of the things we discovered.

**Rethinking Android app compilation with Buck**  
https://code.facebook.com/posts/1894440204217410/rethinking-android-app-compilation-with-buck/  
Several years ago we built and open-sourced Buck, a build tool designed from the ground up for fast iteration, allowing engineers to compile and run changes quickly. We’ve continued to steadily improve Buck’s performance, together with a growing community of other organizations that have adopted Buck and contributed back. But these improvements have largely been incremental in nature and based on long-standing assumptions about the way software development works. In the end, we completely reimagined the way Buck compiles Java code, unlocking performance gains unachievable through incremental improvements. Today we’re open-sourcing a new feature in Buck that will bring these performance improvements to Android engineers everywhere.

**Ten Extras for Great API Documentation**  
https://alistapart.com/article/ten-extras-for-great-api-documentation  
If you manage to create amazing API documentation and ensure that developers have a positive experience implementing your API, they will sing the praises of your product. Continuously improving your API documentation is an investment, but it can have a huge impact. Great documentation builds trust, differentiates you from your competition, and provides marketing value.

**体验，不只是用户的！Ant Design 在蚂蚁中台的应用**  
https://zhuanlan.zhihu.com/p/26846739  
对于 UI/UX ，中台/企业级服务就像是冰山不曾裸露的一角，就像是用户体验不曾到达的处女地。
关键词：中台、Ant Design、antd、互联网金融、设计者、UCAN 。本文将分为 5 个部分为你展开：A.背景阐述；B.解决思路；C.具体做法；D.总结和展望；E.相关材料。预计阅读时间 10 分钟。

**ECharts V3.8 发布**  
http://efe.baidu.com/blog/echarts-3-8-0/  
在 ECharts 新发布的 3.8 版本 中，新加入了 树图，支持 横向布局、纵向布局、径向布局；新加入了 SVG 渲染支持（beta 版） 的支持，从而可以根据自己的需要，选择 SVG 或者 Canvas 作为渲染引擎；代码的模块系统改用 ES Module，从而能够受益于 tree shaking 减小 bundle 的体积；同时开放了构建脚本协助用户进行 自定义模块、语言地构建。另外，ZRender官网beta版也上线了，可以在 https://ecomfe.github.io/zrender-doc/public/  查阅文档和教程啦！

**设计稿自动生成可用页面的展望**  
http://www.cnblogs.com/sskyy/p/7813943.html  
这篇文章只打算描述我加入支付宝之后，在设计稿生成代码这个方向上自己做的尝试和看到的团队中的尝试。不谈行业历史，不争论方向。文章以现状的形成和我的想法演进为主脉络，文末会提到我所看到的新契机。

**蚂蚁金服如何用小团队支撑数亿人买买买**  
https://mp.weixin.qq.com/s?__biz=MjM5MDE0Mjc4MA==&mid=2650999000&idx=1&sn=c42a29f64a23a6ebbe9f546364718042  
从 2010 年的每秒 300 笔，到 2016 年的每秒 12 万笔，交易笔数提升的背后，是蚂蚁金服技术能力被“逼”着快速升级。[阿里云11·11：DataV的数据可视化之道](https://mp.weixin.qq.com/s?__biz=MzIwNjQwMzUwMQ==&mid=2247485575&idx=1&sn=01e614d8787f83c2917809f225e1c336)

**这几年，我在video上踩的坑**  
https://mp.weixin.qq.com/s?__biz=MzA4NjE3MDg4OQ==&mid=2650965439&idx=1&sn=eaf10ff43859931fb121a7c2d541a296  
这篇文章我们从Video的几种应用场景、各环境中依然或将长期存在的问题、基于原生Video进行业务开发常见的问题等方面，一起学习了解更多的实践方向和可能存在的坑。

**Simple React Patterns**  
http://lucasmreis.github.io/blog/simple-react-patterns/  
I've been writing React applications for a few years now, and I've noticed that some patterns tend to repeat themselves. In this post, I'll review these patterns which will summarize about 99% of the React code I write every day. As a sample spec, let's build an app that fetches information about the Dagobah planet from Star Wars API and shows it to the user.

**How Redux Can Make You a Better Developer**  
https://medium.cobeisfresh.com/how-redux-can-make-you-a-better-developer-30a094d5e3ec  
I’m not here to promote Redux, but to explain to you why I think that you should learn Redux and how it can make you a better developer in general. 

**Advanced React Router concepts**  
https://blog.logrocket.com/advanced-react-router-concepts-code-splitting-animated-transitions-scroll-restoration-recursive-17096c0cf9db  
In this tutorial, I’ll highlight some advanced React Router concepts like code splitting, animated transitions, scroll restoration, recursive path, and server-side rendering.

**Yarn: From Zero to 700,000 User Searches per Month**  
https://blog.algolia.com/yarn-search-javascript-packages/  
This blog post explains how we collaborated with the Yarn team, what the challenges were building such a search interface, and how much this search is used today.

**Why we are not cross-platform developers**  
https://android.jlelse.eu/why-we-are-not-cross-platform-developers-fd7ef70e976d  
Here at Pixplicity, where we’ve been making apps for over six years, things are no different: though we started out exclusively as native Android developers before we offered full-spectrum solutions, over the years we’ve tried and tested many of the cross-platform solutions out there, like PhoneGap, Xamarin and React. In the end, we’ve always preferred native solutions for both Android and iOS. Let me try to explain our preference in this post. 另附：[React Native vs Real Native Apps](https://codeburst.io/react-native-vs-real-native-apps-ad890986f1f).

**How JavaScript works: Deep dive into WebSockets and HTTP/2 with SSE + how to pick the right path**  
https://blog.sessionstack.com/how-javascript-works-deep-dive-into-websockets-and-http-2-with-sse-how-to-pick-the-right-path-584e6b8e3bf7   
这个系列的文章都挺详细的，

**How The BBC Has Been Trying Out HTTP/2**  
https://medium.com/bbc-design-engineering/http-2-is-easy-just-turn-it-on-34baad2d1fb1  
The optimisations in h2 make it an attractive proposition for BBC Online, so we ran some simple trials on BBC website content to establish the likely benefits to our audience. 另附：[Enabling Secure HTTP for BBC Online](https://medium.com/bbc-design-engineering/enabling-secure-http-for-bbc-online-media-4c8b597f69f)

**Why Stream Stopped Using .IO Domain Names for Production Traffic**  
https://getstream.io/blog/stop-using-io-domain-names-for-production-traffic/  
Over the past year, IO domain outages have been the number one reason our customers couldn’t use Stream. Specifically, the outage on September 20th, 2017 turned out to be a major headache. This article will go into the details behind the .IO domain name reliability issues and how we’re working around them.

**Deploying IPv6 in Dropbox Edge Network**  
https://blogs.dropbox.com/tech/2017/11/deploying-ipv6-in-dropbox-edge-network/  
In this article, we share our experiences and lessons from enabling IPv6 in the edge network. We will cover the IPv6 design in the edge, the changes we made to support IPv6, how IPv6 was tested and rolled out to users, and issues we encountered. 

**Creating Secure Password Resets With JSON Web Tokens**  
https://www.smashingmagazine.com/2017/11/safe-password-resets-with-json-web-tokens/  
A JWT provides a URL-safe token that, when generated securely, makes for a more secure password-reset process by ensuring that a malicious user cannot easily generate their own token. This article focused on the password-reset process by securing the password-reset flow with a URL-safe token that is validated with a signature. 

**THE MAGIC OF CSS**  
http://adamschwartz.co/magic-of-css/  
CSS is a mess. We all love it, but it’s a mess. I liken it to English: there are a bunch of rules, and you can learn them. But sometimes you’re better off just trying shit and seeing what works and what doesn’t. Magic is a codification of what I’ve learned in that crazy process. The material in this textbook is intermediate-to-advanced. It assumes an understanding of the CSS syntax, cascading and inheritance, and commonly used selectors. It also assumes you’ve had enough experience with CSS to have learned not to make these common mistakes anymore.

**An Update on Reddit’s Redesign**  
https://redditblog.com/2017/11/08/an-update-on-reddits-redesign/  
Well, ten months and several rounds of user and moderator testing later, we’re excited to share  the very first look at the upcoming redesign. While we still have lots of improvements to the UI, feature set, and moderation flow still in the works, we’re excited to start by sharing a preview of two of the most important features in the redesign: a new set of community styling tools and an easier way for users to post to their favorite communities.

**Creating a Star to Heart Animation with SVG and Vanilla JavaScript**  
https://css-tricks.com/creating-star-heart-animation-svg-vanilla-javascript/  
In [my previous article](https://css-tricks.com/emulating-css-timing-functions-javascript/), I've shown how to smoothly transition from one state to another using vanilla JavaScript. The last example showcased making the shape of a mouth to go from sad to glad by changing the d attribute of the path we used to draw this mouth. Manipulating the path data can be taken to the next level to give us more interesting results, like a star morphing into a heart.

**Flexbox and Grids, your layout’s best friends**  
https://aerolab.co/blog/flexbox-grids/  
We decided to debunk the myths around Flexbox & Grids in order to show you the power of these two technologies working together.

**iPhone X Web Navigation Concept**  
https://medium.muz.li/iphone-x-web-navigation-concept-c06efc0e0c50  
Choosing hamburger menu button or tab bar navigation is an old debate in mobile application design. At the moment, it seems that tab bar navigation is winning thanks to the ever increasing mobile screen sizes. 附：[iPhone X 适配 手Q H5页面通用解决方案](https://mp.weixin.qq.com/s?__biz=MjM5MTA1MjAxMQ==&mid=2651227274&idx=1&sn=e06ba689991bf4be168e50e44994b035)

**Simple Tips to Improve User Testing**  
https://blogs.adobe.com/creativecloud/simple-tips-to-improve-user-testing/  
Usability testing involves observing users as they use a product. It helps you find where users struggle and what they like. There are two ways to run a usability test: Moderated, in which a moderator works with a test participant; Unmoderated, in which the test participant completes the test alone. We’ll focus on the first, but some of the tips mentioned can be applied to both types of testing.

**Feature Visualization**  
https://distill.pub/2017/feature-visualization/  
How neural networks build up their understanding of images. Neural feature visualization has made great progress over the last few years. As a community, we’ve developed principled ways to create compelling visualizations. We’ve mapped out a number of important challenges and found ways of a addressing them.

**Eight years of Go**  
https://blog.golang.org/8years  
Since Go was first open sourced we have had 10 releases of the language, libraries and tooling with more than 1680 contributors making over 50,000 commits to the project's 34 repositories; More than double the number of contributors and nearly double the number of commits from only two years ago. This year we announced that we have begun planning Go 2, our first major revision of the language and tooling.

## 新鲜货

**W3C Designates WebRTC 1.0 Feature Complete**  
https://www.programmableweb.com/news/w3c-designates-webrtc-10-feature-complete/brief/2017/11/03  
W3C has announced that [WebRTC 1.0](https://www.programmableweb.com/api/webrtc) is now feature complete. Despite WebRTC's growing popularity, the realtime communications API was until now a W3C Candidate Recommendation. With the new designation, W3C is calling for broad implementation and testing.

**码农·解锁机器学习（第30期）**  
http://www.ituring.com.cn/book/2569  
本期《码农》聚焦机器学习，解锁它的含义、任务、发展历程，在工业界、医学界和大众生活场景中的应用。工业界要想有新的突破，必须走“制造+智能化”的道路。“通过数据挖掘、数据分析找到顾客的需求，提供更多的服务，替顾客创造更多的价值，”工业4.0专家李杰在图灵访谈中这样阐述工业4.0的发展方向。在医疗方面，美国杜克大学医学院神经生物学教授、法国科学院院士、巴西科学院院士、畅销书《脑机穿越》作者米格尔·尼科莱利斯认为，他希望通过人类大脑直接控制外部设备，帮助病人恢复失去的功能，获得更多的灵活性和更好的移动性。另附：[AlphaGo Zero - How and Why it Works](http://tim.hibal.org/blog/alpha-zero-how-and-why-it-works/)

**cube-ui**  
https://github.com/didi/cube-ui  
A fantastic mobile ui lib implement by Vue. 附：[滴滴开源Web移动端组件库cube-ui 独特技术大幅优化性能](https://www.toutiao.com/i6485949527801987598/)

**react-reconciler**  
https://github.com/facebook/react/blob/master/packages/react-reconciler/README.md  
This is an experimental package for creating custom React renderers. Its API is not as stable as that of React, React Native, or React DOM, and does not follow the common versioning scheme. Use it at your own risk.

**React log**  
https://github.com/diegomura/react-log  
react-log exports a single React Component called Log. Each child will not be rendered on the DOM, but will produce an analog representation on the console. No proprietary syntax is needed for child HTML elements. react-log handles the parsing and rendering of native React-DOM elements for you.

**react-mde**  
https://github.com/andrerpena/react-mde  
A simple yet powerful and extensible Markdown Editor editor for React, inspired by GitHub.

**Emergence.js**  
https://github.com/xtianmiller/emergence.js  
Emergence.js is a lightweight, high-performance JS plugin for detecting and manipulating elements in the browser. This plugin is designed to allow manipulation on elements depending on their visibility in the browser. It gives the developer the freedom to use their own CSS or JS to determine what happens; whether it's animation or a change in state. 

**Noel - A universal, human-centric, replayable event emitter**  
https://github.com/lifenautjoe/noel  
The world just like software is full of events. Sometimes these events occur while we are busy doing other things. Wouldn't it be nice to have a way to replay all events? Noel is the way. By being able to replay events we can design reactive systems without having to worry about timing.

**Getopts**  
https://github.com/JorgeBucaran/getopts  
Getopts is 10 to 20 times faster than the alternatives. 

**Webpack Monitor**  
https://github.com/webpackmonitor/webpackmonitor  
Webpack Monitor is a configurable Webpack plugin that captures relevant statistics on your production builds, and an interactive analysis tool that helps developers better understand bundle composition and identify and prioritize optimization strategies.

**GitHub welcomes all CI tools**  
https://github.com/blog/2463-github-welcomes-all-ci-tools  
There are several CI and CD tools that integrate with GitHub, some of which you can install in a few clicks from GitHub Marketplace. With so many options, you can pick the best tool for the job—even if it's not the one that comes pre-integrated with your system.

**Earth on AWS - Build planetary-scale applications in the cloud with open geospatial data**  
https://aws.amazon.com/earth/  
Landsat 8 data is available for anyone to use via Amazon S3. All Landsat 8 scenes from 2015 are available along with a selection of cloud-free scenes from 2013 and 2014. All new Landsat 8 scenes are made available each day, often within hours of production. The satellite images the entire Earth every 16 days at a roughly 30 meter resolution. 

**Tufte CSS**  
https://edwardtufte.github.io/tufte-css/  
[Tufte CSS](https://github.com/edwardtufte/tufte-css) provides tools to style web articles using the ideas demonstrated by Edward Tufte’s books and handouts. Tufte’s style is known for its simplicity, extensive use of sidenotes, tight integration of graphics with text, and carefully chosen typography. This project is directly inspired by and based on [Tufte-LaTeX](https://tufte-latex.github.io/tufte-latex/) and the [R Markdown Tufte Handout](http://rmarkdown.rstudio.com/examples/tufte-handout.pdf).

**The best Icon Tool - Orion Icon Library**  
https://orioniconlibrary.com/  
We worked hard on launching Orion Icon Library and making it the best Icon Library and App on the web.

**Sketch Tools for Managing a Design System**  
https://medium.com/sketch-app-sources/sketch-tools-for-managing-a-design-system-ca8845d1903b  
List of sketch app extensions for organizing and maintaining a user interface collection.

**Your email is about to get awesome**  
http://markdown-here.com/index.html  
Markdown Here will help you to write email more quickly and powerfully than you thought possible. With no extra effort on your part, Markdown Here eliminates all the hassle of formatting email. Empowerment through simplicity.

**Weave Scope**  
https://github.com/weaveworks/scope  
Monitoring, visualisation & management for Docker & Kubernetes. Weave Scope automatically generates a map of your application, enabling you to intuitively understand, monitor, and control your containerized, microservices based application.

**Announcing Prometheus 2.0**  
https://prometheus.io/blog/2017/11/08/announcing-prometheus-2-0/  
Nearly one and a half years ago, we released Prometheus 1.0 into the wild. The release marked a significant milestone for the project. We had reached a broad set of features that make up Prometheus' simple yet extremely powerful monitoring philosophy. Since then we added and improved on various service discovery integrations, extended PromQL, and experimented with a first iteration on remote APIs to enable pluggable long-term storage solutions. But what else has changed to merit a new major release?

## 产品及其它

**10 Lessons of an MIT Education**  
http://www.math.tamu.edu/~cyan/Rota/mitless.html  
You can and will work at a desk for seven hours straight, routinely. By and large, "knowing how" matters more than "knowing what." You don't have to be a genius to do creative work. The future belongs to the computer-literate-squared... 

**Why Channels?**  
https://stackoverflow.blog/2017/11/09/why-channels/  
Stack Overflow Channels is a place for you and your technical team to ask and answer proprietary questions in a secure environment. As we continue to work on Channels, we wanted to share with you our vision, the thinking behind the product and its intricacies, and insight into the process behind developing it. Not all product problems have been solved, and we hope that we can take you along for the journey. This post is the first in a series on how we’re making Channels.

**傅盛：自我进化是一切**  
https://mp.weixin.qq.com/s?__biz=MjM5NjgzMzkwMQ==&mid=2653646426&idx=1&sn=8e2675b64537f97d5624ad3410dc37b8  
一个人真正的成长，就是不断自我进化。这也是《原则》这本书最核心的思想。一个人最大的障碍就是自己。这障碍，不是人本身，其实是思维。改造思维的关键是让自己成为一个shaper。如果把人看成一个独立的生命体，当生命处于1.0阶段，它开始产生信息交换与流动；当生命处于2.0阶段时，它就能成为一个对自己的生命进行自我改变的shaper。自我进化并不是一件轻松的事情。它有非常多的障碍，其中最大的障碍就是ego（自我）。

**微信2017数据报告**  
https://mp.weixin.qq.com/s?__biz=MTEwNTM0ODI0MQ==&mid=2653434887&idx=1&sn=4d346df8c952d48cc2db6064d71f67d2
11月9日，微信团队在成都腾讯全球合作伙伴大会上为全球伙伴解读了最新的《2017微信数据报告》。微信每天有多少条消息被发送？目前有多少个行业已经在使用小程序了？答案尽在其中：）

-- THE  END --

