---
layout: post
title: 'FEX 技术周刊 - 2018/04/16'
author: Dafrok
tag: weekly
---

微信搜索『FEX』关注我们的公众号，及时获得最新资讯。

## 业界会议

**IEEE Pacific Visualization Symposium**  
http://itolab.is.ocha.ac.jp/pvis2018/  
PacificVis is a unified visualization symposium, welcoming all areas of visualization research such as: information visualization, scientific visualization, graph and network visualization, visual analytics, and specific applications such as (but not limited to) security-, software- and bio-visualization.  
附：[北大可视化研究小组的参会见闻](http://vis.pku.edu.cn/blog/)

## 深阅读

**The Eponymous Laws of Tech**  
https://daverupert.com/2018/04/eponymous-laws-of-tech/  
A compendium of tech-related laws, fallacies, and other wisdom

**Front-End Developer Handbook 2018**  
https://frontendmasters.com/books/front-end-handbook/2018/  
This is a guide that anyone could use to learn about the practice of front-end development. It broadly outlines and discusses the practice of front-end engineering: how to learn it and what tools are used when practicing it in 2018. The book should not be considered a comprehensive outline of all resources available to a front-end developer. The value of the book is tied up in a terse, focused, and timely curation of just enough categorical information so as not to overwhelm anyone on any one particular subject matter.

**Announcing Flutter beta 2**  
https://medium.com/flutter-io/https-medium-com-flutter-io-announcing-flutters-beta-2-c85ba1557d5e  
Improvements in our second beta: Easier installation, Improved developer tools, Improved asset system, Dart 2 enabled by default, Dart 2 and optional new/const.  
附：[Why Flutter Will Change Mobile Development for the Best](https://android.jlelse.eu/why-flutter-will-change-mobile-development-for-the-best-c249f71fa63c)

**Crafting Interpreters**  
http://www.craftinginterpreters.com/  
This book contains everything you need to implement a full-featured, efficient scripting language. You’ll learn both high-level concepts around parsing and semantics and gritty details like bytecode representation and garbage collection. Your brain will light up with new ideas, and your hands will get dirty and calloused. It’s gonna be a blast.

**Node.js can HTTP/2 push!**  
https://medium.com/the-node-js-collection/node-js-can-http-2-push-b491894e1bb1  
Since introducing HTTP/2 into Node.js 8 in July of 2017, the implementation has undergone several rounds of improvements. Now we’re almost ready to lift the “experimental” flag. It’s best to try out HTTP/2 support with Node.js version 9, which has all the latest fixes and improvements. 另附：[V8 6.6 Landed on Node.js Core](https://github.com/nodejs/node/compare/78cd8263354705b767ef8c6a651740efe4931ba0...82e475dc75751df08d80bd6e25926bd25c1794f2), [npm Acquires ^Lift Security and Node Security Platform](http://blog.npmjs.org/post/172793182214/npm-acquires-lift-security-and-node-security).

**JavaScript and Node.js Security – The Common Pitfalls**  
https://snyk.io//blog/javascript-and-nodejs-security-the-common-pitfalls/  
JavaScript and Node.js have shown themselves to be amazing platforms. Their sheer ease of use has empowered an entire community of creative individuals to build amazing things. Like in all cases, however, amongst the goodness lurk some risks. Nobody’s perfect, including Node.js and JavaScript, and a language’s strength can quickly translate to its vulnerability if looked through through an evil (or paranoid) lens. I’ve given many talks about JavaScript security, looking to do my share in raising awareness and to keep our applications safer.  
另附：[Attitudes to security in the JavaScript community](http://blog.npmjs.org/post/172774747080/attitudes-to-security-in-the-javascript-community), [Incident Post-Mortem and Security Advisory: Data Exposure After travis-ci.com Outage](https://blog.travis-ci.com/2018-04-03-incident-post-mortem)

**Creating custom URL shortener with Nodejs**  
https://codeburst.io/creating-custom-url-shortener-with-nodejs-de10bbbb89c7  
Here, I am using Nodejs for building the shortener service.

**Implementing SOLID and the onion architecture in Node.js with TypeScript and InversifyJS**  
https://dev.to/remojansen/implementing-the-onion-architecture-in-nodejs-with-typescript-and-inversifyjs-10ad  
In this article, we are going to describe an architecture known as the onion architecture. The onion architecture is a software application architecture that adheres to the SOLID principles. It uses the dependency injection principle extensively, and it is profoundly influenced by the Domain Driven Design (DDD) principles and some functional programming principles.

**Automated Canary Analysis at Netflix with Kayenta**  
https://medium.com/netflix-techblog/automated-canary-analysis-at-netflix-with-kayenta-3260bc7acc69  
We have open sourced [Kayenta](https://github.com/spinnaker/kayenta), a platform for Automated Canary Analysis (ACA). Kayenta leverages lessons learned over the years of delivering rapid and reliable changes into production at Netflix. It is a crucial component of delivery at Netflix as it reduces the risk from making changes in our production environment. In addition, Kayenta has increased developer productivity by providing engineers with a high degree of trust in their deployments.

**Looking to Listen: Audio-Visual Speech Separation**  
https://research.googleblog.com/2018/04/looking-to-listen-audio-visual-speech.html  
People are remarkably good at focusing their attention on a particular person in a noisy environment, mentally “muting” all other voices and sounds. Known as the cocktail party effect, this capability comes natural to us humans. However, automatic speech separation — separating an audio signal into its individual speech sources — while a well-studied problem, remains a significant challenge for computers.  
另附：[谷歌发布「与书对话」检索引擎，从字里行间邂逅心仪书籍](https://www.leiphone.com/news/201804/mGWpse2M8Fnn5Vcs.html)

**Give Meaning To 100 Billion Events A Day - The Analytics Pipeline At Teads**  
http://highscalability.com/blog/2018/4/9/give-meaning-to-100-billion-events-a-day-the-analytics-pipel.html  
In this article, we describe how we orchestrate Kafka, Dataflow and BigQuery together to ingest and transform a large stream of events. When adding scale and latency constraints, reconciling and reordering them becomes a challenge, here is how we tackle it.

**Fixing reachability to 1.1.1.1, GLOBALLY!**  
https://blog.cloudflare.com/fixing-reachability-to-1-1-1-1-globally/  
This blog focuses on IPv4. We provide four IPs (two for each IP address family) in order to provide a path toward the DNS resolver independent of IPv4 or IPv6 reachability.

**Fuchsia is not Linux**  
https://fuchsia.googlesource.com/docs/+/master/the-book/  
This document is a collection of articles describing the Fuchsia operating system, organized around particular subsystems. Sections will be populated over time.

**Why SQLite Does Not Use Git**  
https://sqlite.org/whynotgit.html  
SQLite does not use the Git version control system. SQLite uses Fossil instead, which is a version control system that was specifically designed and written to support SQLite. People sometimes ask why SQLite does not use the Git version control system like everybody else. This article attempts to answer that question. Also, in section 3, this article provides hints to Git users about how they can easily access the SQLite source code.

**The Mathematics of 2048: Optimal Play with Markov Decision Processes**  
http://jdlm.info/articles/2018/03/18/markov-decision-process-2048.html  
In this post, we’ll use a mathematical framework called a Markov Decision Process to find provably optimal strategies for 2048 when played on the 2x2 and 3x3 boards, and also on the 4x4 board up to the 64 tile.

**WHY DOES "=" MEAN ASSIGNMENT?**  
https://www.hillelwayne.com/post/equals-as-assignment/  
The usual answer is “because of C”. But that’s just passing the buck: why does C do it that way? Let’s find out!  
另附：[For mathematicians, = does not mean equality]
(https://jeremykun.com/2018/04/13/for-mathematicians-does-not-mean-equality/)

## 新鲜货

**GitHub 10 years**  
https://blog.github.com/2018-04-10-ten-years-of-code/  
On this day 10 years ago, GitHub officially went live. We started with a pretty simple purpose: to connect developers and make it easier for them to work together on projects with Git. In the last decade, we’ve evolved as a company and as a platform, but the reason why GitHub exists is fundamentally the same. What makes this platform special isn’t an idea or an invention. It’s the people using it—and GitHub is celebrating 10 years because of you, our community.

**CKEditor 5 v1.0.0 beta released**  
https://ckeditor.com/blog/CKEditor-5-v1.0.0-beta-released/  
The plan for the first beta release was to continue implementing new features, but our main goal was to review the entire public API of CKEditor 5 Framework and improve it where possible.

**Bootstrap 4.1**  
https://blog.getbootstrap.com/2018/04/09/bootstrap-4-1/  
Today we’re shipping our first minor release, v4.1! This release comes later than expected and some of the fixes we intended, but there’s still a boatload of fixes, docs updates, build tool changes, and even a few small new features.

**Redux v4.0.0-rc.1**  
https://github.com/reactjs/redux/releases/tag/v4.0.0-rc.1  
There haven't been any big complaints with the previous beta, so it's time to graduate to a release candidate. Please give this a try in your applications and let us know if you see any issues. If we're all clear, I'll get 4.0 released in the next week!

**New WebKit Features in Safari 11.1**  
https://webkit.org/blog/8216/new-webkit-features-in-safari-11-1/  
Service Worker API, Payment Request API for Apple Pay, Beacon API, Directory Upload & Clipboard API Updates...  
另附：[Chrome and Firefox will support a new standard for password-free logins](https://www.theverge.com/2018/4/10/17215406/webauthn-support-chrome-firefox-edge-fido-password-free)、[IPFS Companion 2.2.0 brings window.ipfs to your Browser](https://blog.ipfs.io/35-ipfs-companion-2-2-0/)/、[Move DOM 4.1 to Candidate Recommendation](https://github.com/w3c/dom/issues/175).

**Sneak Peek at WebAssembly Studio**  
https://hacks.mozilla.org/2018/04/sneak-peek-at-webassembly-studio/  
WebAssembly.Studio is an online IDE (integrated development environment) that helps you learn and teach others about WebAssembly. It’s also a Swiss Army knife that comes in handy whenever working with WebAssembly.

**New in Electron 2: In-App Purchases**  
https://electronjs.org/blog/in-app-purchases  
One of the highlights from this new major version is a new inAppPurchase API for Apple's Mac App Store. In-app purchases enable content or subscriptions to be purchased directly from within apps. This gives developers an easy way to embrace the freemium business model, wherein users pay nothing to download an app and are offered optional in-app purchases for premium features, additional content, or subscriptions.

**百度小程序上线**  
https://baijiahao.baidu.com/s?id=1597523372277815436

**各大 App 可以直接打开微信小程序**  
http://www.ifanr.com/minapp/1012686

**VuePress**  
https://vuepress.vuejs.org/  
Vue-powered Static Site Generator

**React Spring**  
https://github.com/drcmda/react-spring  
Helping react-motion and animated to become best friends.  
另附：[Why React needed yet another animation library. Introducing: react-spring](https://medium.com/@drcmda/why-react-needed-yet-another-animation-library-introducing-react-spring-8212e424c5ce).

**redux-beacon**  
https://github.com/rangle/redux-beacon  
Analytics integration for Redux and ngrx/store

**react-beautiful-dnd**  
https://github.com/atlassian/react-beautiful-dnd  
Beautiful, accessible drag and drop for lists with React.js

**A javascript finite state machine library**  
https://github.com/jakesgordon/javascript-state-machine  
A library for finite state machines.

**Cytoscape.js**  
https://github.com/cytoscape/cytoscape.js  
Cytoscape.js is a fully featured graph theory library. Do you need to model and/or visualise relational data, like biological data or social networks? If so, Cytoscape.js is just what you need. Cytoscape.js contains a graph theory model and an optional renderer to display interactive graphs. This library was designed to make it as easy as possible for programmers and scientists to use graph theory in their apps, whether it's for server-side analysis in a Node.js app or for a rich user interface.

**In-Browser ML-Powered Object Detection Demo**  
https://github.com/ModelDepot/tfjs-yolo-tiny-demo  
Using Tensorflow.js, we're able to use deep learning to detect objects from your webcam! Your webcam feed never leaves your computer and all the processing is being done locally! (Trust me, we can't afford the servers to store/process your data).  
另附：[TensorFlow 中文开发者社区](https://www.tensorflowers.cn/)

**EdgeDB: A New Beginning**  
https://edgedb.com/blog/edgedb-a-new-beginning/  
In a few weeks we will release the first public technology preview of EdgeDB—a new open-source object-relational database. This post is a brief introduction and the first in the series. Before diving in, let’s take a look what motivated us to build EdgeDB.

**next generation video: Introducing AV1**  
https://people.xiph.org/~xiphmont/demo/av1/demo1.shtml  
AV1 is a new general-purpose video codec developed by the Alliance for Open Media. The alliance began development of this new codec using Google's VPX codecs, Cisco's Thor codec, and Mozilla's/Xiph.Org's Daala codec as starting point. AV1 leapfrogs the performance of VP9 and HEVC, making it a next-next-generation codec. The AV1 format is and will always be royalty-free with a permissive FOSS license.  
另附：[Facebook - AV1 beats x264 and libvpx-vp9 in practical use case](https://code.facebook.com/posts/253852078523394/av1-beats-x264-and-libvpx-vp9-in-practical-use-case/)

**Android container in Chrome OS**  
https://chromium.googlesource.com/chromiumos/platform2/+/master/arc/container-bundle/  
This document outlines the process by which Android runs in a Linux container in Chrome OS. This document explains how the container for Android master works unless otherwise noted. The container for N may work in a slightly different way.

**go-internals**  
https://github.com/teh-cmc/go-internals  
go-internals is a work-in-progress book about the internals of the Go (1.10+) programming language.  
另附：[goruby](https://github.com/goruby/goruby).

**Structured text tools**  
https://github.com/dbohdan/structured-text-tools  
The following is a list of text-based file formats and command line tools for manipulating each.

## 设计

**How To Design Emotional Interfaces For Boring Apps**  
https://www.smashingmagazine.com/2018/04/designing-emotional-interfaces-boring-apps/  
Humans can’t endure boredom for a long time, which is why products that are built for non-exciting, repetitive tasks so often get abandoned and gather dust on computers and phones. But boredom, according to psychologists, is merely lack of stimulation, the unfulfilled desire for satisfying activity. So what if we use the interface to give them that stimulation? I sat with product designers here at MacPaw, who spend their waking hours designing not-so-sexy things like duplicate finders and encryption apps, and they shared five secrets to more emotional UIs: gamification, humor, animation, illustration, and mascots.

**Brutalist design is the bad influence we all need**  
https://www.imaginarycloud.com/blog/why-we-need-web-brutalism/  
The UX/UI world has gradually come to be dominated by guidelines and aesthetics belonging to companies like Apple or Google. It’s absolutely normal and predictable that this would happen, considering most apps are designed to seamlessly fit into the user experience of technologies belonging to these big titans.

**Top 3 Things Charter Learned About Reusable Designs and Components**  
https://blog.angular.io/top-3-things-charter-learned-about-reusable-designs-and-components-dd367de32122  
Modern web app development is complicated. Even when you go it alone, you’re faced with innumerable decisions. Which libraries and frameworks will you choose? How will you structure your code? What syntax rules will you follow? How will you build and deploy the app?

**Color: From Hexcodes to Eyeballs**  
http://jamie-wong.com/post/color/  
Why do we perceive background-color: #9B51E0 as this particular purple? This is one of those questions where I thought I’d known the answer for a long time, but as I inspected my understanding, I realized there were pretty significant gaps. Through an exploration of electromagnetic radiation, optical biology, colorimetry, and display hardware, I hope to start filling in some of these gaps.

**Light or Dark UI? Tips to Choose a Proper Color Scheme for User Interface**  
https://uxplanet.org/light-or-dark-ui-tips-to-choose-a-proper-color-scheme-for-user-interface-9a12004bb79e  
Today we are going to discuss one of the frequent choices UI designers have to make project by project: which scheme is better for the interface, light or dark?

**Pitfalls of Card UIs**  
https://daverupert.com/2018/04/pitfalls-of-card-uis/  
An optimistic design choice that ends up compounding complexity.

## 产品及其它

**Publishers Haven't Realized Just How Big a Deal GDPR is**  
https://baekdal.com/strategy/publishers-havent-realized-just-how-big-a-deal-gdpr-is/  
So, in this article, I'm going to talk about GDPR as a concept in relation to media trends, and consider what this means for your editorial strategies. I hope I can help you realize just how big a change this actually is.  
另附：[America should borrow from Europe’s data-privacy law](https://www.economist.com/news/leaders/21739961-gdprs-premise-consumers-should-be-charge-their-own-personal-data-right)、[Facebook Urged to Adopt GDPR Globally as a Standard
](https://techcrunch.com/2018/04/09/facebook-urged-to-make-gdpr-its-baseline-standard-globally/)

**It'S Time For An Rss Revival**  
https://www.wired.com/story/rss-readers-feedly-inoreader-old-reader/  
THE MODERN WEB contains no shortage of horrors, from ubiquitous ad trackers to all-consuming platforms to YouTube comments, generally. Unfortunately, there's no panacea for what ails this internet we've built. But anyone weary of black-box algorithms controlling what you see online at least has a respite, one that's been there all along but has often gone ignored. Tired of Twitter? Facebook fatigued? It's time to head back to RSS.  
另附：[RSS is undead](https://techcrunch.com/2018/04/07/rss-is-undead/).

**Hello: A new social network founded by Orkut's creator**  
http://www.orkut.com/index.html  
hello is the first social network built on loves, not likes. I designed hello to help you connect with people who share your passions. hello connects us all. Think about it: you can say "hello" in any language and people will understand. "Hello" is probably the most widely spoken word in the world after "Okay." Aló, halo, ʾāllo, alô, hallo, alló, hello. Fear and hatred have no place when you make such a simple and friendly gesture to someone else. So come join me, and make some new friends. Say hello, and love your world.

**How To Be a Systems Thinker**  
https://www.edge.org/conversation/mary_catherine_bateson-how-to-be-a-systems-thinker  
At the moment, I’m asking myself how people think about complex wholes like the ecology of the planet, or the climate, or large populations of human beings that have evolved for many years in separate locations and are now re-integrating. To think about these things, I find that you need something like systems theory. So, I went back to thinking about systems theory two or three years ago, which I hadn’t for quite a long time.

**快手&抖音用户研究报告**  
https://mp.weixin.qq.com/s?__biz=MTEwNTM0ODI0MQ==&mid=2653435310&idx=1&sn=356dc50735369d320046964a9e122105  
不论是“南抖音，北快手”，还是“快手是小镇青年的，抖音是都市白领的”，这些论述更多是来自于使用者对周围的感性判断——而对快手和抖音这两个月活用户数以亿计的产品而言，他们的用户到底分布在哪里，有着怎样的特征和偏好，我们期待通过数据和分析，给大家一个更完整的对比性研究。  
另附：[2017年度中国数字阅读白皮书](https://mp.weixin.qq.com/s?__biz=MjM5OTU5MDYyMw==&mid=2653355380&idx=1&sn=6e3a890e71f480d84bbe8c5bdca0855a)

**[译]增长黑客 VS 价值黑客**  
http://36kr.com/p/5128132.html  
专注于一个指标，并试图不惜一切代价将其提高，是实现增长的合理途径吗？在工程师拉杰德拉 · 拉斯马纳（Rajendra Rusmana）看来，这种做法偏离了产品的本质——为用户提供价值。按照这种方式去推动增长，必然会到达瓶颈，因为增长黑客本质上是一个最优化问题。为了突破这个瓶颈，应该将目光转移到价值上，成为一个价值黑客。
