---
layout: post
title: 'FEX 技术周刊 - 2018/10/15'
author: 2betop
tag: weekly
---

## 深阅读

**Rethinking Unit Test Assertions**  
https://medium.com/javascript-scene/rethinking-unit-test-assertions-55f59358253f  
The problem with most test frameworks is that they’re so busy making it easy for you to take shortcuts with their “convenient” assertions that they forget that the biggest value of a test is realized when the test fails. At the failure stage, the convenience of writing the test matters a lot less than how easy it is to figure out what went wrong when we read the test.

**12 Factor CLI Apps**  
https://medium.com/@jdxcode/12-factor-cli-apps-dd3c227a0e46  
At Heroku, we’ve come up with a methodology called the 12 factor app. It’s a set of principles designed to make great web applications that are easy to maintain. In that spirit, here are 12 CLI factors to keep in mind when building your next CLI application. Following these principles will offer CLI UX that users will love.

**Death by a thousand cuts - a checklist for eliminating common React performance issues**  
https://logrocket-blog.ghost.io/death-by-a-thousand-cuts-a-checklist-for-eliminating-common-react-performance-issues/  
A pragmatic step-by-step guide to eliminating common react performance issues.

**Start Performance Budgeting**  
https://addyosmani.com/blog/performance-budgets/  
If you're building a web experience and want to stay fast, a performance budget can be critical. For success, embrace performance budgets and learn to live within them. Network & CPU limits on mobile can require asking hard questions like, "what is really important to my users?"

**The Suspense is Killing Redux**  
https://medium.com/@ryanflorence/the-suspense-is-killing-redux-e888f9692430  
At my latest workshops I’ve been getting this question: So does Suspense kill Redux? First, that’s a rude way to put it. But I get it, the suspense is killing you — or maybe Redux.

**[译]再见，面向对象编程**  
https://mp.weixin.qq.com/s?__biz=MzU0Nzk1MTg5OA==&mid=2247483877&idx=1&sn=39cc95efadec791b8ca572e27d94ef92  
几十年来，我一直都在使用面向对象语言编程。 我使用的第一个面向对象语言是C ++，接着是Smalltalk，最后是.NET和Java。我曾经是面向对象三大范式：继承，封装和多态，狂热的拥趸者，为他们的所带来的遍历疯狂。我渴望得到它（面向对象）所承诺的重用性，并期待自己能站在前人的肩膀上，进入这块全新、美好的土地。一想到只要将现实世界的物体映射到他们对应的类中，他们就能整齐的找到自己的位置，我就无法抑制自己的兴奋。但“我不能错的更多”。

**前端安全系列之二：如何防止CSRF攻击**  
https://tech.meituan.com/fe_security_csrf.html  
相比XSS，CSRF的名气似乎并不是那么大，很多人都认为“CSRF不具备那么大的破坏性”。真的是这样吗？接下来，我们还是有请小明同学再次“闪亮”登场。

**精致化的微前端开发之旅**  
https://zhuanlan.zhihu.com/p/46284079  
微前端（Micro-Frontend），是将微服务（Micro-Services）理念应用于前端技术后的相关实践，使得一个前端项目能够经由多个团队独立开发以及独立部署。本文中将会以此为目标，从零构建一套微前端的开发方案的最佳实践*，并用于完成 Micro Frontends 网站中的示例应用。

**深拷贝的终极探索**  
https://yanhaijing.com/javascript/2018/10/10/clone-deep/  
本文我将给大家破解深拷贝的谜题，由浅入深，环环相扣，总共涉及4种深拷贝方式，每种方式都有自己的特点和个性。

**Why We Decided to Rewrite Uber’s Driver App**  
https://eng.uber.com/rewrite-uber-carbon-app/  
This article is the first in a series covering how Uber’s mobile engineering team developed the newest version of our driver app, codenamed Carbon, a core component of our ridesharing business. Among other new features, the app lets our population of over three million driver-partners find fares, get directions, and track their earnings. We began designing the new app in conjunction with feedback from our driver-partners in 2017, and began rolling it out for production in September 2018.

**Understanding the difference between grid-template and grid-auto**  
https://bitsofco.de/understanding-the-difference-between-grid-template-and-grid-auto/  
To summarize, the grid-template-* properties are used to create, place, and size cells for the explicit grid. Any cell that exists in the grid that is not explicitly created by this property forms part of the implicit grid, which can be sized by the grid-auto-* properties.

**Building Enterprise Software on LinkedIn's Consumer Stack: Behind the Scenes of LinkedIn Talent Hub**  
https://engineering.linkedin.com/blog/2018/10/building-linkedin-talent-hub  
In this blog post, we will discuss the foundational building blocks that were either built from scratch, or created by modifying existing platforms, to power LinkedIn’s new Talent Hub product.

**Why we need the distributed web**  
https://www.ctrl.blog/entry/the-dweb  
The distributed web seeks to make peer-to-peer content distribution the new default. This should help make the web topology more democratic and resilient to nature and political whims.

**Infrastructure as Code - Getting Started with Terraform**  
https://blog.scottlogic.com/2018/10/08/infrastructure-as-code-getting-started-with-terraform.html  
This blog post serves as a brief introduction to what Infrastructure as Code is, as well as how to get started using it with Terraform. Although Terraform can be used with many cloud providers, the post focuses particularly on deploying resources to AWS.

**Dropbox traffic infrastructure: Edge network**  
https://blogs.dropbox.com/tech/2018/10/dropbox-traffic-infrastructure-edge-network/  
Dropbox has more than half a billion registered users who trust us with exabytes of data and petabytes of corresponding metadata. For the Traffic team this means millions of HTTP requests and terabits of traffic. To support all of that we’ve built an extensive network of points of presence (PoPs) around the world that we call Edge. 另附 Dropbox 的 [Using machine learning to index text from billions of images](https://blogs.dropbox.com/tech/2018/10/using-machine-learning-to-index-text-from-billions-of-images/)

**Applying machine intelligence to GitHub security alerts**  
https://blog.github.com/2018-10-09-applying-machine-intelligence-to-security-alerts/  
We created a machine learning model that scans text associated with public commits (the commit message and linked issues or pull requests) to filter out those related to possible security upgrades. With this smaller batch of commits, the model uses the diff to understand how required version ranges have changed.

**Writing system software: code comments**  
http://antirez.com/news/124  
In this post I analyze Redis comments, trying to categorize them.  Along the way I try to show why, in my opinion, writing comments is of paramount importance in order to produce good code, that is maintainable in the long run and understandable by others and by the authors during modifications and debugging activities.

## 新鲜货

**CKEditor 5 v11.1.0 released**  
https://ckeditor.com/blog/CKEditor-5-v11.1.0-released/  
This editor version brings the long-awaited media embed feature, support for block content in tables, tables available in real-time collaborative editing and many smaller features and improvements. We also streamlined our Operational Transformation engine to improve its support for already implemented collaboration features as well as those planned in the near future (like “suggestion mode”).

**Ionic 4 Beta: What’s New and Building a Sample App**  
https://auth0.com/blog/ionic-4-beta-whats-new-and-building-a-sample-app/  
In this article, you will learn about what's new in Ionic 4, changes in the existing features, how to migrate your Ionic 3 app to Ionic 4 app, and about using Ionic with Stencil and Capacitor. Finally, you will create a simple application using Ionic 4 to see the new version of this framework in action. 

**Custom Elements Now 'In Development' on Microsoft Edge**  
https://developer.microsoft.com/en-us/microsoft-edge/platform/status/customelements/  
Edge is the last major browser to get on board with custom elements. Shadow DOM is being worked on, too. 另附：[Firefox to support Google's WebP image format for a faster web](https://www.cnet.com/news/firefox-to-support-googles-webp-image-format-for-a-faster-web/)

**Microsoft Joins the Open Invention Network Community**  
https://globenewswire.com/news-release/2018/10/10/1619375/0/en/Microsoft-Joins-the-Open-Invention-Network-Community.html  
Microsoft’s participation in OIN will drive additional innovation and enhance patent non-aggression in Linux and adjacent OSS technologies. 另附：[又提倡开源，又不给资金、人力资源，谁之过](https://mp.weixin.qq.com/s?__biz=MjM5MDE0Mjc4MA==&mid=2651009895&idx=1&sn=33e2805efde81f28fc1629b004bcce10)

**Calls between JavaScript and WebAssembly are finally fast**  
https://hacks.mozilla.org/2018/10/calls-between-javascript-and-webassembly-are-finally-fast-%F0%9F%8E%89/  
In the latest version of Firefox Beta, calls between JS and WebAssembly are faster than non-inlined JS to JS function calls. 另附：[Walt is a JavaScript-like syntax for WebAssembly text format](https://github.com/ballercat/walt).

**WorkerDOM**  
https://github.com/ampproject/worker-dom  
An in-progress (as in very-alpha) implementation of the DOM API intended to run within a Web Worker. Purpose: Move complexity of intermediate work related to DOM mutations to a background thread, sending only the necessary manipulations to a foreground thread.

**baffle.js**  
https://github.com/camwiegert/baffle  
A tiny javascript library for obfuscating and revealing text in DOM elements.

**Hover**  
https://github.com/IanLunn/Hover  
A collection of CSS3 powered hover effects to be applied to links, buttons, logos, SVG, featured images and so on. Easily apply to your own elements, modify or just use for inspiration. Available in CSS, Sass, and LESS. 

**Bloom Filter**  
https://github.com/jasondavies/bloomfilter.js  
This JavaScript bloom filter implementation uses the non-cryptographic [Fowler–Noll–Vo hash function](http://isthe.com/chongo/tech/comp/fnv/) for speed.

**awesome-mongodb**  
https://github.com/ramnes/awesome-mongodb  
A curated list of awesome MongoDB resources, libraries, tools and applications. 另附：[mLab is becoming a part of MongoDB](https://blog.mlab.com/2018/10/mlab-is-becoming-a-part-of-mongodb-inc/).

**Muze - Composable data visualisation library for web with a data-first approach**  
https://github.com/chartshq/muze  
Compose data-driven layers to create interactive visualizations in JavaScript with relational algebra supported data model.

**Flatbush**  
https://github.com/mourner/flatbush  
A really fast static spatial index for 2D points and rectangles in JavaScript. An efficient implementation of the packed Hilbert R-tree algorithm. Enables fast spatial queries on a very large number of objects (e.g. millions), which is very useful in maps, data visualizations and computational geometry algorithms.

**Ferret**  
https://github.com/MontFerret/ferret  
ferret is a web scraping system aiming to simplify data extraction from the web for such things like UI testing, machine learning and analytics. Having its own declarative language, ferret abstracts away technical details and complexity of the underlying technologies, helping to focus on the data itself. It's extremely portable, extensible and fast.

**Boltons**  
https://github.com/mahmoud/boltons  
Boltons is a set of over 220 BSD-licensed, pure-Python utilities in the same spirit as — and yet conspicuously missing from — the standard library. 另附：[Camelot, a Python Library to Extract Tabular Data from PDFs](https://blog.socialcops.com/technology/engineering/camelot-python-library-pdf-data/).

**Turn the web into a database: An alternative to web crawling/scraping**  
https://www.mixnode.com/blog/posts/turn-the-web-into-a-database-an-alternative-to-web-crawling-scraping  
Mixnode turns the web into a giant database! In other words, Mixnode allows you to think of all the web pages, images, videos, PDF files, and other resources on the web as rows in a database table; a giant database table with trillions of rows that you can query using the standard Structured Query Language (SQL).

**NVIDIA and Open-Source Ecosystem Come Together to Accelerate Data Science**  
https://blogs.nvidia.com/blog/2018/10/10/rapids-data-science-open-source-community/  
While the world’s data doubles each year, CPU computing has hit a brick wall with the end of Moore’s law. For this reason, scientific computing and deep learning have turned to NVIDIA GPU acceleration. Data analytics and machine learning haven’t yet tapped into the GPU as systematically. That’s changing.

## 设计

**Designing Experiences To Improve Mental Health**  
https://www.smashingmagazine.com/2018/10/designing-experiences-improving-mental-health/  
Designing apps for mental health is one area where UX designers can have a huge impact. In this article, we’ll look at the issues with current apps, and guidelines to ensure UX practitioners are using clinically proven methods for improving mental health treatment.

**Here’s What You Need to Know About Color Accessibility in Product Design**  
https://uxplanet.org/heres-what-you-need-to-know-about-color-accessibility-in-product-design-aecbd0c30628  
As a Product Designer at Handsome, I recently worked with a client to create the most complex implementation of an accessible color system that I’ve had a chance to work on, and thought I’d pass along some of my learnings.

**Designing a Styleguide: Elements That Go Into Building Compelling Products**  
https://blog.marvelapp.com/designing-styleguide-elements-building-compelling-products/  
The goal of this article is to introduce you to some well-thought-out styleguides and branding guidelines. It also details some of the most important elements every styleguide should have.

## 产品及其它

**InVision has no physical headquarters and all 700 employees work remotely**  
https://www.businessinsider.com/invision-startup-all-employees-work-remotely-2018-9  
All 700 employees at this startup work remotely. Here's why one of its top execs says it's given them a major edge over the competition.

**任正非：告别"完人"预设，拥抱巨大无穷性**  
https://mp.weixin.qq.com/s/rB4V5RpvgDnksmQJEKR2OA  
世间人生百态，许多意见会误导你的人生，经历一次次的吃亏是福，终于到一个节点上你意识到，水往低处流，能量向居下的人聚集。甘居后者反而领先，甘居下者反而为上，谦卑，敬畏，居下，开放，包容，是成就点事最重要的品质。当然世界需要你独一无二的价值！这时，你就走上了回归的道路，回归你真正的天赋天性，回归你为人类创造价值的初心。另附：[异类华为](https://mp.weixin.qq.com/s/dC_rHsDn5KCOF9PjwCUJsg).

**为什么是黄峥？**  
https://mp.weixin.qq.com/s?__biz=MzUyMDQ5NzI5Mg==&mid=2247499454&idx=1&sn=8685ee7536854a3861a61f9212175181  
人的思想很容易被染污的，当人对一件事情做判断的时候，往往要了解背景和事实，之后需要的不是睿智，而是面对事实时是否有勇气依然用理性、用常识来判断。

**It doesn't have to be crazy at work**  
https://basecamp.com/books/calm  
[阮老师推荐](http://www.ruanyifeng.com/blog/2018/10/weekly-issue-26.html)的这本书蛮不错的。是不是一定要那么多加班？这本书说，也不是。加班多的一个因素是，公司没有好好珍惜员工的时间，打断工作的事情特别多，最典型的举措就是开放式办公室，使得人们互相干扰，员工因此不得不加班，因为在正常时间内无法完成工作。作者认为，公司应该创造条件，让员工全身心投入工作，不要拖到夜深人静时才能没有打扰。同时，这本书也指出，IT 公司的工作任务也确实过多：无休止的需求、不断的营销活动、精确到小时的排期，都给工程师带来了焦虑和压力。普通的行业，用户一年增长一倍，绝对是值得庆祝的，但是 IT 行业不行。这个行业渴望的是一年增长十倍，甚至百倍，要的是从0变成独角兽的那种速度。这本书的主张是，软件行业也可以是一个平静的行业，而不一定像现在这样，是一个加速再加速的行业。平静才是长期可持续发展的关键。另附：[来自Y Combinator的一份40岁的人生建议](https://mp.weixin.qq.com/s/qiw9egPTsQpAmEAjORrWjw).

-- THE END --