---
layout: post
title: 'FEX 技术周刊 - 2019/04/30'
author: hefangshi
tag: weekly
---

## 深阅读

**Faster and more feature-rich internationalization APIs**  
https://v8.dev/blog/intl  
ECMA-402, or Intl provides key locale-specific functionality such as date formatting, number formatting, plural form selection, and collation. The Chrome V8 and Google Internationalization teams have been collaborating on adding features to V8’s ECMA-402 implementation, while cleaning up technical debt and improving performance and interoperability with other browsers. 另附：[A year with Spectre: a V8 perspective](https://v8.dev/blog/spectre)

**Introducing Node.js 12**  
https://medium.com/@nodejs/introducing-node-js-12-76c41a1b3f3f  
Highlighted updates and features include faster startup and better default heap limits, updates to V8, TLS, llhttp, new features including diagnostic report, bundled heap dump capability and updates to Worker Threads, N-API and ES6 module support and more. 另附：[Node 12's New Experimental ES Modules Support(https://medium.com/@nodejs/announcing-a-new-experimental-modules-1be8d2d6c2ff).

**Svelte 3: Rethinking reactivity**  
https://svelte.dev/blog/svelte-3-rethinking-reactivity  
[Svelte](https://svelte.dev/) is a component framework — like React or Vue — but with an important difference. Traditional frameworks allow you to write declarative state-driven code, but there's a penalty: the browser must do extra work to convert those declarative structures into DOM operations, using techniques like  that eat into your frame budget and tax the garbage collector. Instead, Svelte runs at build time, converting your components into highly efficient imperative code that surgically updates the DOM. As a result, you're able to write ambitious applications with excellent performance characteristics.

**Application State Management with React**  
https://kentcdodds.com/blog/application-state-management-with-react  
Here's the real kicker, if you're building an application with React, you already have a state management library installed in your application. You don't even need to npm install (or yarn add) it. It costs no extra bytes for your users, it integrates with all React packages on npm, and it's already well documented by the React team. It's React itself. React is a state management library.

**从前端角度看企业软件的研发过程**  
https://www.yuque.com/xufei-coder/code/fd0gv5  
一直以来，企业软件前端工程体系处于一个很尴尬的局面，无数前端对它有过各种吐槽：技术栈老旧、封闭，体验差，而项目和交付经理又会觉得开发效率太低。据我所见，大部分吐槽的人并没有理解造成这些状况的深层原因，或者说，当自己去构建这么一套体系的时候，并不理解在选型和技术集成过程中，存有哪些可能的决策点。本文尝试从一些角度去给出自己的见解，为了说明构建这个领域前端技术体系的种种考虑，同时也会述及对应的业务特性。

**百度应用层智能网络演进**  
https://mp.weixin.qq.com/s?__biz=MzUyMzA3MTY1NA==&mid=2247484929&idx=1&sn=3d6b26e04486fd10240b5908998627c8  
在爆发式增长的情况下，网络接入必须能快速响应各种层面需求，保证用户访问体验流畅。简单来说，在网络接入要做到访问加速、接入高可用、安全防攻击等。而在移动时代的下一幕人工智能时代，万物互联，语音交互……更需要在网络接入时有针对性优化的解决方案。谁拥有快速、稳定、安全网络接入技术，谁才有能力应对起业务增长与服务用户的挑战。云端网络统一接入、网络流量智能调度、终端网络优化组件，是支撑移动与智能时代的网络接入核心技术。另附：[百度智能交通技术派 - 不止于2D，酷炫的地图3D热力图实现解析](https://mp.weixin.qq.com/s?__biz=MzI5NDQ2Nzk3Ng==&mid=2247485057&idx=1&sn=90a39ee5674347ea5d98aceb030a072d)。

**展望 React 17，回顾 React 往事**  
https://zhuanlan.zhihu.com/p/40160380  
要讨论未来（React 17），必须要了解过去。以 React 16 为分水岭，我们可以分为两方面来看这个问题。一是为什么，二是怎么办。

**Understanding WebViews**  
https://www.kirupa.com/apps/webview.htm  
When it comes to accessing internet content, we typically use a browser like Chrome, Firefox, Safari, Internet Explorer, and Edge. You are probably using one of those browsers right now to read this article! While browsers are pretty popular for the whole task of accessing internet content, they have some serious competition that we probably never paid much attention to. This competition comes in the form of something known as a WebView. This article will explain all about what this mysterious WebView is and why it is sorta kinda cool.

**JavaScript minification**  
http://neugierig.org/software/blog/2019/04/js-minifiers.html  
JavaScript applications are written as a collection of .js files that are usually transformed before being served in a browser. One reason to transform is to improve page load time. There are two primary components to improving page load time: bundling multiple files together, and minifying to make the bundle size smaller. This post walks through why we do these and what the implications are for doing such a thing, and concludes with a few projects I've been working on to improve this space (spoiler: comparitive benchmarks).

**Introducing CLI Builders**  
https://blog.angular.io/introducing-cli-builders-d012d4489f1b  
In this blog post, we’re going to look at a new API in Angular CLI, which allows you to add CLI features and augment existing ones. We’ll discuss how to interact with this API and what are the extension points which allow you to add additional features to the CLI.

**Comparing JVM alternatives to JavaScript**  
https://renato.athaydes.com/posts/comparing-jvm-alternatives-to-js.html  
I am mostly a backend developer, but every now and then I need to do some frontend work. Even if just for personal use. For that reason, I’ve been following developments in the JavaScript world from a distance, but I dislike much of what I see.

**Elixir, Phoenix, Absinthe, GraphQL, React, and Apollo: an absurdly deep dive**  
https://schneider.dev/blog/elixir-phoenix-absinthe-graphql-react-apollo-absurdly-deep-dive/  
If you’re anything like me, at least 3 or 4 of the keywords in the title of this article fall under the category of “things I’ve been wanting to play with but haven’t gotten around to it yet.” React is the exception; I use it almost every day at work and know it front and back. I used Elixir for a project a couple of years ago, but it’s been a while and I’ve never used it in the context of GraphQL. Similarly, I’ve done a small amount of work on a project that used GraphQL with a Node.js backend and Relay on the frontend, but I barely scratched the surface of GraphQL and I’ve never used Apollo. I firmly believe that the best way to truly learn a technology is to build something with it, so I decided to take a deep dive and build a web application with all of these technologies together. If you want to skip to the end, the code is on GitHub and there’s a live demo here.

**Using Clean Architecture for Microservice APIs in Node.js with MongoDB and Express**  
https://www.youtube.com/watch?v=CnailTcJV_U  
In this video we talk about Bob Martin's Clean Architecture model and I will show you how we can apply it to a Microservice built in node.js with MongoDB and Express JS. 

## 新鲜货

**Intelligent Tracking Prevention 2.2**  
https://webkit.org/blog/8828/intelligent-tracking-prevention-2-2/  
As of ITP 2.2, persistent cookies set through document.cookie are capped to one day of storage when both of the following conditions are met: A domain classified with cross-site tracking capabilities was responsible for navigating the user to the current webpage. The final URL of the navigation mentioned above has a query string and/or a fragment identifier. The rest of this blog post explores this in detail.

**GitLab 11.10**  
https://about.gitlab.com/2019/04/22/gitlab-11-10-released/  
GitLab 11.10 released with Pipelines on the Operations Dashboard, Pipelines for Merged Results, and Multi-line Merge Request Suggestions.

**Highlights from Git 2.21**  
https://github.blog/2019-02-24-highlights-from-git-2-21/  
The open source Git project just released Git 2.21 with features and bug fixes from over 60 contributors. We last caught up with you on the latest Git releases when 2.19 was released. Here’s a look at some of the most interesting features and changes introduced since then.

**Electron 5.0.0**  
https://electronjs.org/blog/electron-5-0  
Much of Electron's functionality is provided by the core components of Chromium, Node.js, and V8. Electron keeps up-to-date with these projects to provide our users with new JavaScript features, performance improvements, and security fixes. 

**nginx-1.16.0 stable version has been released**  
http://nginx.org/#2019-04-23  
incorporating new features and bug fixes from the 1.15.x mainline branch - including UDP proxying improvements in the stream module, random load balancing method, support for TLS 1.3 early data, dynamic loading of SSL certificates, and more.

**New version of the Roadmap of Web Applications on Mobile**  
https://www.w3.org/blog/news/archives/7714  
W3C has published a new version of its [Roadmap of Web Applications on Mobile](https://www.w3.org/2019/04/web-roadmaps/mobile/), an overview of the various technologies developed in W3C that increase the capabilities of Web applications, and how they apply more specifically to the mobile context.

**create-react-app 3.0**  
https://github.com/facebook/create-react-app/releases/tag/v3.0.0  
Create React App 3.0 brings some exciting new features including support for Hooks! 另附：[React.js Boilerplate 4.0](https://www.reactboilerplate.com/).

**React Mentions**  
https://github.com/signavio/react-mentions  
A React component that let's you mention people in a textarea like you are used to on Facebook or Twitter.

**Uppy 1.0: Your best friend in file uploading**
https://uppy.io/blog/2019/04/1.0/
After 3 years of development, we are launching version 1.0 of [Uppy](https://github.com/transloadit/uppy), our file uploader for web browsers.

**Corvid by Wix—Advanced Web Application Development**  
https://www.wix.com/corvid  
Accelerated Development of Web Applications. Accelerate your front-end development with the intuitive, visual builder. Use and modify 100s of UI elements to build data applications quickly and efficiently—all while retaining the flexibility of your code.

**An Attempt at Creating a New 'Open' Registry for npm Packages**  
https://open-registry.dev/  
A JavaScript Package Registry funded, developed and maintained by the community, for the community. 另附：[np v5.0.0 - A better `npm publish`](https://github.com/sindresorhus/np)

**Laconia 1.0: A Framework for Building Node.js Serverless Functions**  
https://laconiajs.io/  
Laconia is a microframework for building Node.js serverless function based applications. Laconia allows you to write serverless functions in Hexagonal Architecture easily. All of your serverless functions will have more consistent patterns that are testable, maintainable, and loosely coupled. 另附：[5 Common Misconceptions About Serverless in 2019](https://www.stackery.io/blog/common-misconceptions/)

**Principles and Techniques of Data Science**  
https://www.textbook.ds100.org/  
In this book, we will proceed as though the reader is comfortable with the knowledge presented in Data 8 or some equivalent.

**The Akka 10-Year Anniversary Magazine**  
https://www.lightbend.com/ebooks/akka-10-year-anniversary-magazine  
The 10-Year Akkaversary Magazine is a commemorative guide of white papers, blog posts and articles that have shaped the Akka journey. It’s a collector’s edition of curated content from Akka thought leaders, experts and contributors. In this guide, you will:  
- Learn about the most relevant concepts of Reactive Programming and Reactive Systems  
- Take a deep-dive on building cloud-native services with Akka and Kubernetes  
- Understand how the top experts think about Akka and its future  
- Get a practical overview of Akka techniques and integrations  

**vim.wasm**
https://rhysd.github.io/vim.wasm/  
Vim Ported to WebAssembly. 好厉害...

**Flutter Desktop shells**  
https://github.com/flutter/flutter/wiki/Desktop-shells  
Work is ongoing to extend Flutter to support desktop as a target environment, allowing developers to create macOS, Windows, and Linux applications with Flutter. On the long run, this effort will create lead to a fully integrated solution where flutter create, flutter run, and flutter build work for desktop platforms as they do for mobile platforms, but currently this effort is still under way.

**Termshark**  
https://termshark.io/  
A terminal UI for tshark, inspired by Wireshark.

**Openshot**  
https://www.openshot.org/  
OpenShot Video Editor is available for download on Linux, OS X, and Windows.

**PySnooper - Never use print for debugging again**  
https://github.com/cool-RR/pysnooper  
PySnooper is a poor man's debugger. You're trying to figure out why your Python code isn't doing what you think it should be doing. You'd love to use a full-fledged debugger with breakpoints and watches, but you can't be bothered to set one up right now. You want to know which lines are running and which aren't, and what the values of the local variables are.

**Gitea - Git with a cup of tea**  
https://github.com/go-gitea/gitea  
The goal of this project is to make the easiest, fastest, and most painless way of setting up a self-hosted Git service. Using Go, this can be done with an independent binary distribution across all platforms which Go supports, including Linux, macOS, and Windows on x86, amd64, ARM and PowerPC architectures. Want to try it before doing anything else?

## 设计  

**A Redesign of Google Earth Timelapse Encourages Users to Explore, and Stay for a While**  
https://medium.com/google-design/redesigning-google-earth-timelapse-135a963cc35  
Google Earth Timelapse is a great example of how Google can take a massive amount of data, democratize it, and enlighten us — in this case about the planet we live on. There’s nothing like a living, moving image to show us how the world has changed over decades, as the zoomable video in Timelapse allows us to do for places like the Columbia Glacier or the Tibetan Plateau. Today we’ve improved Timelapse so that the site can tell richer stories about the planet, and more people can share these stories. 

**Gradients in UI Design**  
https://blog.marvelapp.com/gradients-ui-design/  
If you open Dribbble or Behance right now, there is a strong chance you will see dozens of designs that use gradients. The gradients designers use are loud and full of color. In this article, I want to share some tips on how to use gradients in design.

**Sympathy vs. Empathy in UX**  
https://www.nngroup.com/articles/sympathy-vs-empathy-ux/  
As UX professionals, it is our job to advocate on behalf of our users. To do it, we must understand them. Understanding our users means building empathy for human beings who experience the product or service we create. In an effort to practice empathy, many teams mistakenly practice sympathy. Although these words have different meanings, teams often incorrectly use sympathy and empathy interchangeably. This confusion results in a large gap in their understanding and in an inability to address real human needs. The goal of this article is to help you reflect on your current UX practice — are you unknowingly practicing pity and sympathy instead of empathy?

**腾讯顶尖设计团队总结的 2019 – 2020 设计趋势：图形篇**  
https://www.uisdc.com/tencent-isux-2020-design-trend  
ISUX 研究了 2019 年至 2020 年的设计趋势。没有必要去遵循年度设计趋势报告，但是否意识到这一趋势，对设计师来讲却非常重要。首先，我们总结了平面设计的总体趋势，同时也研究了从 Zepeto app 和 Memoji 开始的，最近扩展出来的 IP 形象设计和角色设计趋势。在本文中，我们想分享 ISUX 设计趋势报告的第一部分「图形设计趋势」。在这一部分里，我们展示了当下各种品牌和动态图形的案例，总结了 12 个值得注意的平面设计趋势。

**UCAN 2019 官方全纪录：让商业美而简单**  
https://mp.weixin.qq.com/s/797aBSkF3VyRg62xMMXSsw  
这场由阿里巴巴设计（Alibaba Design）主办的年度设计盛会，今年聚焦的主题是“让商业美而简单”。13 位受邀的设计界大咖、9 大专业论坛、6 场工作坊、1 个派对，UCAN 与到场的超过 4000 名从全国各地赶来的设计师小伙伴一起，探索设计的边界，切近设计的未来。

**Element 动画宣传片制作全过程**  
https://mp.weixin.qq.com/s/tnoV-RpYn2kzudbYwLoL3g  
有一个UI设计师，用了两个多月时间做了一部 Element 动画宣传片，他到底经历了什么...

## 产品及其它  

**How to Create an Institution That Lasts 10,000 Years**  
https://www.edge.org/conversation/alexander_rose-how-to-create-an-institution-that-lasts-10000-years  
We’re also looking at the oldest living companies in the world, most of which are service-based. There are some family-run hotels and things like that, but also a huge amount in the food and beverage industry. Probably a third of the organizations or the companies over 500 or 1,000 years old are all in some way in wine, beer, or sake production. I was intrigued by that crossover.

**I'm one of the inventors of RSS and I need your help to reboot the Internet**  
https://getpolarized.io/2019/04/11/Polar-Initial-Crowdfunding-Campaign.html  
[Polar](https://getpolarized.io/) is a new type of app which helps you build a personal knowledge repository and keeps all your reading in one place. It allows you to annotate all your documents including highlighting and manage them with tags and notes. Polar also supports advanced features like spaced repetition (so you never forget anything again) and web archival so you can view a document forever even if it’s deleted on the original site. More importantly, it’s the starting ramp for a more long term vision around content sharing and knowledge collaboration.

**Winter：从前端到”钱“端，我并不把钱当工作目标，但钱从来也没有亏待我**  
https://mp.weixin.qq.com/s?__biz=MjM5MDE0Mjc4MA==&mid=2651015495&idx=1&sn=7051e6554bbbd5d3bd80e66512dcf41c  
为什么他能在前端圈如鱼得水？为什么他总能拿到大公司的高薪 offer？在他眼中：前端 Leader 都该焦虑什么？为什么过去十年是前端觉醒的十年？在杭州家里，我们采访了本期嘉宾 winter，听他讲述前端行业十年的得与失。另附：[月影 - 工作10年，谈谈我的技术团队管理经验](https://mp.weixin.qq.com/s?__biz=MzUxMzcxMzE5Ng==&mid=2247491051&idx=2&sn=ba5173cafe8222a70774a1b7796974c6)。

**敬畏实体，敬畏勤劳，敬畏二三四线，敬畏90后00后**  
https://mp.weixin.qq.com/s?__biz=MzIxNTAzNzU0Ng==&mid=2654626013&idx=1&sn=4edda01291012da41139138526017b63  
我们围绕着反常识的数据、中国的机遇与优势、实体经济、改变偏见，下沉市场、海外市场，新金融时代等八大版块展开了我对新商业文明时代的看法。总体来说，我相信悲观者往往正确，但乐观者往往成功。这亦是我爱这个时代的原因。

**明道云正式发布**  
https://mp.weixin.qq.com/s/Bc14rVpV3lY_gvMB_cp_aw  
明道云是一个企业软件的快速设计和开发工具。但是，这个开发工具不需要任何代码编写，普通业务人员就能掌握。行业分类上，也将这个品类称为零代码开发平台（No-Code Development Platforms Software），或者快速应用开发工具（Rapid Application Development）。它可以通过灵活的功能组件，让企业可以搭建个性化的CRM、ERP、OA、项目管理、进销存等系统。你可以用它管理生产、销售、采购、人事等所有企业活动。附：[一个不太走运的 SaaS 领域创业者](https://mp.weixin.qq.com/s/31gg9dNKPc-ZtON1TyWSBg)。

**组织蜕变：从追求效率的机器到追求效果的机体**  
https://mp.weixin.qq.com/s?__biz=MzI5MjMyNjk2Mg==&mid=2247489716&idx=1&sn=39f826aaa4be50d3f8742aaa00096d94  
“深井式”组织等级分明，上层负责战略决策，下层负责执行。公司中的绝大多数人都是执行者，对他们而言，只需要正确地做事就可以，而什么是正确的事则是极少数领导者，甚至是唯一领导者的责任。在小型组织中，由于层级较少，顶层设计者能够对一线状况准确把握，据此作出合理布局，“深井式”组织并不会导致太大的问题。一旦组织体量变大，公司层级不断叠加，决策者会自然而然远离“战场前线”，公司信息传递滞后，导致组织僵化，无法及时应对市场变化。尤其在面对当下错综复杂的环境时，这种反应迟钝常常使得昔日的市场霸主被后来者出其不意地颠覆。

> 对数据可视化有兴趣的可以阅读由 AntV 带来的 [墨者修齐 2019-04-29 · 世界森林、线性叙事和探索交互、以电影之名重新标注洛杉矶街道](https://www.yuque.com/mo-college/weekly/hkpbf9)  

-- THE END --