---
layout: post
title: 'FEX 技术周刊 - 2019/05/06'
author: 2betop
tag: weekly
---

## 业界会议

**F8 - 2019**  
https://www.f8.com/  
https://developers.facebook.com/videos/2019/  
会议资料：
- [Building the New facebook.com with React, GraphQL and Relay](https://developers.facebook.com/videos/2019/building-the-new-facebookcom-with-react-graphql-and-relay/)  
- [React Native at F8 and Open Source Podcast](https://facebook.github.io/react-native/blog/2019/05/01/react-native-at-f8-and-podcast.html)  
- [Open source at F8 2019](https://code.fb.com/open-source/f8-open-source/)  
- F8 2019 keynote and session videos: [Day 1](https://code.fb.com/ai-research/f8-2019-day-1/), [Day 2](https://code.fb.com/ai-research/f8-2019-day-2/) 

**DockerCon 2019**
https://www.docker.com/dockercon/  
附：[It’s a Wrap – Highlights from the DockerCon 2019 Keynote Sessions](https://blog.docker.com/2019/05/its-a-wrap-highlights-from-the-dockercon-2019-keynote-sessions/).

## 深阅读

**Local-first software - You own your data, in spite of the cloud**  
https://www.inkandswitch.com/local-first.html  
In this article we propose “local-first software”: a set of principles for software that enables both collaboration and ownership for users. Local-first ideals include the ability to work offline and collaborate across multiple devices, while also improving the security, privacy, long-term preservation, and user control of data.

**How to use React Context effectively**  
https://kentcdodds.com/blog/how-to-use-react-context-effectively  
Don't reach for context to solve every state sharing problem. Context does NOT have to be global to the whole app. You can have multiple logically separated contexts in your app. 另附：[How to useReducer in React?](https://www.robinwieruch.de/react-usereducer-hook/).

**7 Tools for Developing Web Components in 2019**  
https://blog.bitsrc.io/7-tools-for-developing-web-components-in-2019-1d5b7360654d  
In this post, I’ll review 5 unranked tools you should know and consider if you’re thinking one putting web components to use in 2019. 另附：[Making Web Components for Different Contexts](https://css-tricks.com/making-web-components-for-different-contexts/).

**爬取2000篇 Matrix 文章，这是一份可视化踹门教程**  
https://sspai.com/post/54169  
我们处在一个高度信息化的时代， 时刻都会在互联网上留下大量的访问痕迹——数据，小到日常的消费账单，大到一笔一笔的银行流水。这些留下来的海量数据无疑是对现实世界的简化和抽象表达，但对于大部分人来说，它们只是 Excel 里面的行行列列，不仅可读性差，而且晦涩难懂。如何提高数据的可读性，很大程度上取决于你看数据的方式，解读数据的方式。比如，我们可以将抽象的数据再抽象，经过二次抽象的数据变成了图表，反而可读性更高，更利于人们理解。提到数据可视化，Python、R、D3 甚至是 Excel，能够产生美妙图表的工具数不胜数，但它们大多都有一些技术门槛，要求你至少有一些编程基础，这对于非科班出身的人来说，并不友好。所以，我希望能减少对技术的依赖，去寻找一些优秀工具，同样能获得不错的可视化效果。

**Node.js Best Practices**  
https://github.com/i0natan/nodebestpractices  
You are, in fact, reading dozens of the best Node.js articles - this repository is a summary and curation of the top-ranked content on Node.js best practices, as well as content written here by collaborators.

**Node.js v12 - New Features You Shouldn't Miss**  
https://blog.risingstack.com/node-js-12-new-features/  
Node.js v12 is out on schedule! It is going into LTS in October and will be maintained until 2022. Here is a list of changes we consider essential to highlight.

**Understand how to approach designing queues in Node**  
https://www.coreycleary.me/understand-how-to-approach-designing-queues-in-node/  
A new scenario you might not have faced before: you have a long running task (like saving to a bunch of different databases, or processing video) that takes a while to process and it’s currently causing your REST API response times to be way too slow for the end user. After some research, you’ve realized adding a queue to your architecture would solve your problem. The only problem is, working out how a queue actually works is confusing. In this post we’ll be going over the architecture for how a queue works (using the reliable queue pattern) so you can achieve exactly these things.

**The Many Benefits of Using a Monorepo**  
https://pspdfkit.com/blog/2019/benefits-of-a-monorepo/  
We’re extremely happy with our monorepo and plan to move even more projects to it. Along with simplifying the workflows, it brings our various platform teams closer together and encourages them to “dig deeper” and fix issues across all platforms instead of delegating things to other teams.

**GitLab’s journey from Azure to GCP**  
https://about.gitlab.com/2019/05/02/gitlab-journey-from-azure-to-gcp/  
Gitlab Staff Engineer Andrew Newdigate shares how we completed our migration to Google Cloud Platform, and how we overcame   
Dropbox is building features to help users stay focused on what matters. Searching through your content can be tedious, so we built content suggestions to make it easier to find the files you need, when you need them.challenges along the way.

**Real-time Data Processing for Monitoring and Reporting**  
https://medium.com/walmartlabs/real-time-data-processing-for-monitoring-and-reporting-a-practical-use-case-of-spark-structured-8e4f91f6f3a7  
A practical use case of spark structured streaming.

**Using machine learning to predict what file you need next**  
https://blogs.dropbox.com/tech/2019/05/content-suggestions-machine-learning/  
Dropbox is building features to help users stay focused on what matters. Searching through your content can be tedious, so we built content suggestions to make it easier to find the files you need, when you need them. We’ve built this feature using modern machine learning (ML) techniques, but the process to get here started with a simple question: how do people find their files? What kinds of behavior patterns are most common?

**6 Technical Challenges Developing a Distributed SQL Database**  
https://blog.yugabyte.com/6-technical-challenges-developing-a-distributed-sql-database/  
We crossed the three year mark of developing YugaByte DB in February of this year. It has been a thrilling journey thus far, but not without its fair share of technical challenges. There were times when we had to go back to the drawing board and even sift through academic research to find a better solution than what we had at hand. In this post we’ll outline some of the hardest architectural issues we have had to address in our journey of building an open source, cloud native, high-performance distributed SQL database. Look for subsequent posts that will dive-deep into each respective issue. OK, let’s get started exploring these issues from easiest to most challenging.

**I/O Is Faster Than the CPU – Let’s Partition Resources and Eliminate (Most) OS Abstractions**  
https://penberg.org/parakernel-hotos19.pdf  
I/O is getting faster in servers that have fast programmable NICs and non-volatile main memory operating close to the speed of DRAM, but single-threaded CPU speeds have stagnated. Applications cannot take advantage of modern hardware capabilities when using interfaces built around abstractions that assume I/O to be slow. We therefore propose a structure for an OS called parakernel, which eliminates most OS abstractions and provides interfaces for applications to leverage the full potential of the underlying hardware. The parakernel facilitates application-level parallelism by securely partitioning the resources and multiplexing only those resources that are not partitioned.

**A World Run with Code**  
https://blog.stephenwolfram.com/2019/05/a-world-run-with-code/  
This is an edited transcript of a recent talk I gave at a blockchain conference, where I said I’d talk about “What will the world be like when computational intelligence and computational contracts are ubiquitous?”

**Python at Netflix**  
https://medium.com/netflix-techblog/python-at-netflix-bba45dae649e  
As many of us prepare to go to PyCon, we wanted to share a sampling of how Python is used at Netflix. We use Python through the full content lifecycle, from deciding which content to fund all the way to operating the CDN that serves the final video to 148 million members. We use and contribute to many open-source Python packages, some of which are mentioned below. If any of this interests you, check out the jobs site or find us at PyCon. We have donated a few Netflix Originals posters to the PyLadies Auction and look forward to seeing you all there.

## 新鲜货

**Remote Development with VS Code**  
https://code.visualstudio.com/blogs/2019/05/02/remote-development  
We're excited to announce the preview of three new extensions for Visual Studio Code that enable seamless development in Containers, remotely on physical or virtual machines, and with the Windows Subsystem for Linux (WSL). You can get started right away by installing the [Remote Development Extension Pack](https://aka.ms/VSCodeRemoteExtensionPack).

**Easy Automatic npm Publishes**  
https://blog.npmjs.org/post/184553141742/easy-automatic-npm-publishes  
One common question from people using npm to publish, especially on CI systems, is how best to automate the process, especially when dealing with multiple branches. For a while now, I’ve been using a pattern that takes almost all of the human interaction out of it, since I tend to mess stuff up when I type it with my fingers. This works well for automatic publishes from CI or when publishing manually from a terminal.

**Introducing `now dev` – Serverless, on localhost**  
https://zeit.co/blog/now-dev  
Now was born out of the idea that deploying a website could be much simpler. You only have to run a single command: now – that is all. We are excited to announce one command to run it all on localhost: now dev.

**ws: a Node.js WebSocket library v7.0**  
https://github.com/websockets/ws/releases/tag/7.0.0  
Simple to use, blazing fast and thoroughly tested WebSocket client and server for Node.js.

**Owning it: browser compatibility data and open source governance**  
https://hacks.mozilla.org/2019/05/browser-compatibility-data-and-open-source-governance/  
What does it mean to “own” an open-source project? With the [browser-compat-data](https://github.com/mdn/browser-compat-data) project (“BCD”), the MDN (Mozilla Developer Network) community and I recently had the opportunity to find out.

**Editor.js: A Block-Styled Editor with JSON Output**  
https://editorjs.io/  
Editor.js is a Block-Styled editor. Blocks are structural units, of which the Entry is composed. For example, Paragraph, Heading, Image, Video, List are Blocks. Each Block is represented by Plugin. We have many ready-to-use Plugins and a simple API for creating new ones.

**Glide.js**  
https://github.com/glidejs/glide  
Glide.js is a dependency-free JavaScript ES6 slider and carousel. It’s lightweight, flexible and fast. Designed to slide. No less, no more

**Babylon.js 4.0 Is Here!**  
https://blogs.windows.com/buildingapps/2019/04/30/babylon-js-4-0-is-here/  
We cannot be more excited to share that Babylon.js 4.0 has officially been released. This version of Babylon.js is a major step forward in one of the world’s leading WebGL-based, graphics engines. Babylon.js 4.0 represents an incredible amount of hard work by a very passionate community of developers from around the world, and it is our honor to share it with all of you.

**UI Libraries**  
https://github.com/jefflombard/ui-libraries/blob/master/README.md  
A collection of UI Frameworks and their platform implementations.

**Material-UI: Google Material Design-Inspired Components v4.0.0 beta**  
https://github.com/mui-org/material-ui/releases/tag/v4.0.0-beta.0  
React components for faster and easier web development. Build your own design system, or start with Material Design.

**react-testing-library**  
https://github.com/testing-library/react-testing-library  
Simple and complete React DOM testing utilities that encourage good testing practices.

**Relay v4.0.0**  
https://github.com/facebook/relay/releases/tag/v4.0.0  
Relay is a JavaScript framework for building data-driven React applications.

**SQLite compiled to javascript**  
https://github.com/kripken/sql.js  
sql.js is a port of SQLite to Webassembly, by compiling the SQLite C code with Emscripten. It uses a virtual database file stored in memory, and thus doesn't persist the changes made to the database. However, it allows you to import any existing sqlite file, and to export the created database as a javascript typed array.

**Textblock**  
https://github.com/glyphic-co/textblock  
A javascript tool for adjusting size, leading, and grades to cast continuously responsive typography. It works over your current CSS as a progressive enhancement.

**SOUL - The Future of Audio Coding**  
https://soul.dev/  
The SOUL project is creating a new language and infrastructure for writing and deploying audio code. It aims to unlock improvements in latency, performance, portability and ease-of-development that aren't possible with the current mainstream techniques that are being used.

**Apache Software Foundation joins GitHub open source community**  
https://github.blog/2019-04-29-apache-joins-github-community/  
We’re excited to welcome the Apache Software Foundation (ASF) to GitHub. Apache is the world’s largest open source foundation, with over 200 million lines of code managed by an all-volunteer community of 730 members and 7,000 committers. Over their 20 year history, one billion lines of code have been committed across three million code commits. 另附：[Create your own course on GitHub Learning Lab](https://github.blog/2019-05-01-create-your-own-course-on-github-learning-lab/).

**Why Software Projects need Heroes (Lessons Learned from 1100+ Projects)**  
https://arxiv.org/abs/1904.09954  
A "hero" project is one where 80% or more of the contributions are made by the 20% of the developers. In the literature, such projects are deprecated since they might cause bottlenecks in development and communication. However, there is little empirical evidence on this matter. Further, recent studies show that such hero projects are very prevalent. Accordingly, this paper explores the effect of having heroes in project, from a code quality perspective. We identify the heroes developer communities in 1100+ open source GitHub projects. Based on the analysis, we find that (a) hero projects are majorly all projects; and (b) the commits from "hero developers" (who contribute most to the code) result in far fewer bugs than other developers. That is, contrary to the literature, heroes are standard and very useful part of modern open source projects.

**Android App Reverse Engineering 101**  
https://maddiestone.github.io/AndroidAppRE/  
Welcome to AndroidTM App Reverse Engineering 101! This workshop’s goal is to give you the foundations to begin reverse engineering Android applications. While this workshop won’t teach you the details of Android app development, Android malware analysis, Android vulnerability hunting, etc., I hope to give you all the necessary foundations through this workshop such that you can apply your new Android reversing skills to doing those things.

**GNU Guix 1.0.0 released**  
https://www.gnu.org/software/guix/blog/2019/gnu-guix-1.0.0-released/  
Guix is an advanced distribution of the GNU operating system developed by the GNU Project—which respects the freedom of computer users. Guix supports transactional upgrades and roll-backs, unprivileged package management, and more. When used as a standalone distribution, Guix supports declarative system configuration for transparent and reproducible operating systems. It provides Guile Scheme APIs, including high-level embedded domain-specific languages (EDSLs) to define packages and whole-system configurations.

**1MB**  
https://1mb.site/  
1MB is a free and easy static website host.

**Introduction - The Embedded Rust Book**  
https://rust-embedded.github.io/book/intro/index.html  
Embedded Rust is for everyone who wants to do embedded programming while taking advantage of the higher-level concepts and safety guarantees the Rust language provides. 另附：[Risp (in (Rust) (Lisp))](https://m.stopa.io/risp-lisp-in-rust-90a0dad5b116).

## 设计  

**Mobile UX Design Principles and Best Practices**  
https://www.toptal.com/designers/mobile-ui/mobile-ux-design-principles  
Good design is good design, right? True, but there are specialized considerations that come into play depending on the medium for that design. Design principles for something like an app made to run on a desktop computer are usually slightly different from the most effective mobile UX design conventions.

**Ultimate Guide to UX Animation**  
https://uxplanet.org/ultimate-guide-to-ux-animation-f5f7af5a3848  
Animations are frequently used as a tool to demonstrate or explain concepts. Done right, they can really add to the user experience. Not only can they increase understanding, but they can also better hold the user’s attention.

**Designing For The Future With Voice Prototypes**  
https://www.smashingmagazine.com/2019/05/future-design-voice-prototypes/  
Human-machine communication is rapidly expanding to encompass both written and spoken interaction, and it’s essential to be ready to design for both visual and voice. Since prototyping for voice is new for many designers, it may be unclear as to where to start and what process to follow.

## 产品及其它  

**(Th)Inking with data — tapping into the potential of the digital pen**  
https://www.microsoft.com/en-us/research/blog/thinking-with-data-tapping-into-the-potential-of-the-digital-pen/  
The digital experience doesn’t match the sensory aspect—the tactile, visual, and auditory feedback—of the analog experience. Affordability and reliability are also among the many reasons why people might choose pen and paper over the digital option. Instead of seeking to emulate the analog experience, our aspiration is to uncover the unique capabilities of the digital pen. Our research aims to give the digital pen superpowers for marking documents in ways that go beyond what is possible with physical pen and paper.

**Golden - The intelligent, open knowledge base**  
https://golden.com/  
https://golden.com/blog/introducing-golden/  
Explore the world's first self-constructing knowledge database built by artificial and human intelligence.

**Microsoft, Slack, Zoom, and the SaaS Opportunity**  
https://stratechery.com/2019/microsoft-slack-zoom-and-the-saas-opportunity/  
It is difficult to discuss enterprise software without at least mentioning Microsoft, and there is no better time than now: last week the company (briefly) became the third U.S. company, after Apple and Amazon, to achieve a market capitalization of over $1 trillion, and is currently the most valuable publicly-listed company in the world.

**吴军 - 人类也许高估了20年后发生的事**  
https://mp.weixin.qq.com/s?__biz=MzIxNTAzNzU0Ng==&mid=2654626358&idx=2&sn=3cc5dfeec8f6a09841ec94c62fd4a530  
三年前, 开启了人工智能时代，“它能做的事越来越多，几乎所有的事都可以做”，这是一种普遍的看法。但是任何时候，如果一个事物当所有人都觉得它能做时，都有两个可能性：一是这个事确实太厉害了；再一个可能也发展到头了。因为所有人都看到的事，红利未必还能继续存在。这时恰是需要一个冷静的思考。换个角度来看，就是人工智能不能做什么。

**腾讯更新了愿景和使命**  
https://mp.weixin.qq.com/s?__biz=MjM5MDczODM3Mw==&mid=2653028879&idx=1&sn=b97040a40b21717528dbb440fb9d28f2  
腾讯的愿景是什么？做一个令人尊敬的企业，这是他自己的问题。但是它没有使命，没有明确提出要为社会解决什么问题。直到去年下半年腾讯架构调整后，马化腾对外讲话里多出一个使命，“公司的使命是利用数字创新提升人类生活品质。”，现在腾讯将公司的使命和愿景都统一成了一个词：科技向善。

-- THE END --