---
layout: post
title: 'FEX 技术周刊 - 2019/05/13'
author: exialym
tag: weekly
---

## 业界会议  

**Google IO 2019**  
https://events.google.com/io/  
主题是：[Building a more helpful Google for everyone](https://blog.google/technology/developers/io19-helpful-google-everyone/)、相关资讯：[Google I/O：酷科技将拉平这个世界](https://www.geekpark.net/news/241598)、[Google Fights Back](https://stratechery.com/2019/google-fights-back/)。话题很多，可以找感兴趣的去看，前端相关的有这几个尤其值得关注：  
- [Elevating the Web Platform with the JavaScript Framework Community (Google I/O ’19)](https://www.youtube.com/watch?v=-xZHWK-vHbQ)  
- [Flutter: a Portable UI Framework for Mobile, Web, Embedded, and Desktop](https://developers.googleblog.com/2019/05/Flutter-io19.html)  
- [Create App-like Experiences on Google Search and the Google Assistant (Google I/O'19)](https://www.youtube.com/watch?v=0Hyt7gjHYO4)  
- [Actions on Google at I/O 2019: New tools for web, mobile, and smart home developers](https://developers.googleblog.com/2019/05/Actions-on-Google-at-IO-2019.html)  
- [What’s new in JavaScript](https://www.youtube.com/watch?v=c0oy0vQKEZE)  
- [What's new with Chrome and the Web](https://blog.chromium.org/2019/05/google-io-2019-whats-new-with-chrome.html)  

同期举办的还有 [Microsoft Build 2019](https://www.microsoft.com/en-us/build)，总结：[微软抢先 Google 开了一场「真·开发者大会」，关键词是责任和开放](https://www.geekpark.net/news/241545)
  

**QCon北京2019**  
https://2019.qconbeijing.com/  
附：W3C Web 技术总负责人 Philippe Le Hégaret 的分享 [Now and the Future: An Overview of the Web in 2019](https://mp.weixin.qq.com/s?__biz=MzUxMzcxMzE5Ng==&mid=2247491186&idx=1&sn=235f648fccaf0e2769fa5044418a8b4d).

## 深阅读  

**Why Mason And Front-End As A Service Will Be A Game Changer For Product Development**  
https://www.smashingmagazine.com/2019/05/mason-front-end-service-product-development/  
Software development and maintenance has, generally speaking, been a time-consuming and arduous process for developers and engineers who carry the brunt of the work. However, with the introduction of front-end-as-a-service, and a company like Mason pioneering the way, that could all change. Here’s what you need to know about FEaaS.

**Open source collaborative text editors**  
https://juretriglav.si/open-source-collaborative-text-editors/  
For years now I've had this itch, trying to find the "perfect" collaborative text editor. But not just any collaborative text editor, oh no, my speciality is finding (well, at least looking for) open source real-time collaborative web-based rich text editors (i.e. not just plain text, but structured content as well). The focus of this post is thus on this quite niche category of open source tools and the tech that powers them, but if your interests are wider, you can check out this [constantly updated list of editors](https://github.com/JefMari/awesome-wysiwyg).

**Why are 2D vector graphics so much harder than 3D?**  
https://blog.mecheye.net/2019/05/why-is-2d-graphics-is-harder-than-3d-graphics/  
To those not well-versed in the details of the modern GPU, it’s a very surprising conclusion! But 2D graphics has plenty of unique constraints that make it a difficult problem to solve, and one that doesn’t lend itself well to parallel approaches. Let’s take a stroll down history lane and trace the path that led us here in the first place, shall we?

**SVG Will Save Us**  
https://www.youtube.com/watch?v=sxte3WpyO60  
SVGs are one of the most underutilized technologies on the web. They can be the most performant, flexible, and accessible image formats. In this session, Sarah will cover a few practical things like styling SVG icons like typography, and then dive into the creative wilds of this graphic format built with math. She'll make it respond to physics, make it bounce and snap, and make it interactive with front-end frameworks like Vue.js and React. In this session Sarah will push the boundaries of what's possible while also thinking about cross-browser stability, and you'll come out of it with a whole new world of tools in your front-end developer toolbox.

**API 设计最佳实践的思考**  
https://mp.weixin.qq.com/s/qWrSyzJ54YEw8sLCxAEKlA  
API 是模块或者子系统之间交互的接口定义。好的系统架构离不开好的 API 设计，而一个设计不够完善的 API 则注定会导致系统的后续发展和维护非常困难。接下来，阿里巴巴研究员谷朴将给出建议，什么样的 API 设计是好的设计？好的设计该如何做？

**HTTP API 认证授权术**  
https://coolshell.cn/articles/19395.html  
本篇文章会覆盖如下技术：HTTP Basic; Digest Access; App Secret Key + HMAC; JWT – JSON Web Tokens; OAuth 1.0 – 3 legged & 2 legged; OAuth 2.0 – Authentication Code & Client Credential.

**阿里巴巴“数据库侠客”**  
http://mp.weixin.qq.com/s?__biz=MzU0NDEwMTc1MA==&mid=2247492406&idx=1&sn=fd2684669ede0824e7d184349df4d48d  
数据库工程师半夜起床的日子再也没了，自动化运维程序的精致让过去的热血蜷缩在日志里。吹过原野的风目睹了那些草莽英雄撤离战场，顶级院校的计算机大神扛起大旗。人们在曾经野兽横行的荒原上，建起了安静细密的城市。历史曾有一万条岔路，阿里巴巴理应庆幸自己如今仍是互联网大潮中的一朵巨浪。而互联网浪潮，又是中国厚厚自传中的一章。

**How we optimized Magic Pocket for cold storage**  
https://blogs.dropbox.com/tech/2019/05/how-we-optimized-magic-pocket-for-cold-storage/  
In this post, we’ll discuss another advance in storage technology at Dropbox: a new cold storage tier that’s optimized for less frequently accessed data. This storage runs on the same SMR disks as our more active data, and through the same internal network.

**Predicting Stack Overflow Tags with Google’s Cloud AI**  
https://stackoverflow.blog/2019/05/06/predicting-stack-overflow-tags-with-googles-cloud-ai/  
We wanted to build a machine learning model that would resonate with developers, so Stack Overflow was a great fit. In order to train a high accuracy model we needed lots of Stack Overflow data. Luckily such a dataset exists in BigQuery. This dataset includes a 26 GB table of Stack Overflow questions updated regularly (you can explore the dataset in BigQuery here). In this post I’ll walk through building the model, understanding how the model is making predictions with SHAP, and deploying the model to Cloud AI Platform.

**We Can Do Better Than SQL**  
https://edgedb.com/blog/we-can-do-better-than-sql/  
SQL started with a goal to empower non-programmers to work with the relational data effectively. Despite its shortcomings, it has arguably been wildly successful, with most databases implementing or emulating it. However, like any solution, SQL is facing increasing inadequacy in the support of the new requirements, modes of use and user productivity. It is time we do something about it.

**The reason I am using Altair for most of my visualization in Python**  
http://fernandoi.cl/blog/posts/altair/  
Altair is a wrapper for [Vega-Lite](https://vega.github.io/vega-lite/), a JavaScript high-level visualization library. One of Vega-LiteIn the rest of the article, I will mainly refer to Altair, but Vega-Lite deserves as much (or more) credit. Most important features is that its API is based in the grammar of graphics. Grammar of graphics may sound like an abstract feature, but it is the main difference between Altair and other Python visualization libraries. Altair matches the way we reason about visualizing data.

**IT runs on Java 8**  
https://veekaybee.github.io/2019/05/10/java8/  
In today’s online economy where thousands of developers are online, the person whose voice is the loudest gets the most weight. The loudest people aren’t going to be those working with legacy systems. This piece of the puzzle is the one that worries me the most. What I’m worried about is that places like Hacker News, r/programming, the tech press, and conferences expose us to a number of tech-forward biases about our industry that are overenthusiastic about the promises of new technology without talking about tradeoffs.

**What We’ve Built Is a Computational Language (and That’s Very Important!)**  
https://blog.stephenwolfram.com/2019/05/what-weve-built-is-a-computational-language-and-thats-very-important/  
I’ve sometimes found it a bit of a struggle to explain what the Wolfram Language really is. Yes, it’s a computer language—a programming language. And it does—in a uniquely productive way, I might add—what standard programming languages do. But that’s only a very small part of the story. And what I’ve finally come to realize is that one should actually think of the Wolfram Language as an entirely different—and new—kind of thing: what one can call a computational language.

## 新鲜货  

**AMis**  
https://github.com/baidu/amis  
写吐了增删改查页面和表单？来试试用我们开源的 amis 轻松配出来，无需写代码就能做出各种各样的后台页面。一种页面渲染器，可以直接基于特定格式的 JSON 配置将页面渲染出来，结合业务方 API 可快速完成各类管理页面的开发。目前用于百度内部 AMIS 平台，已有 100+ 部门接入使用，创建 1.2w+ 页面。

**Introducing Windows Terminal**  
https://github.com/Microsoft/Terminal  
https://devblogs.microsoft.com/commandline/introducing-windows-terminal/  
另附来做 Microsoft 的 [Intelligent Productivity and Collaboration, from Anywhere](https://devblogs.microsoft.com/visualstudio/intelligent-productivity-and-collaboration-from-anywhere/)、[Introducing .NET 5](https://devblogs.microsoft.com/dotnet/introducing-net-5/).  

**GitHub Package Registry - Your packages, at home with their code**  
https://github.com/features/package-registry  
With GitHub Package Registry you can safely publish and consume packages within your organization or with the entire world.

**React Native - Build native mobile apps using JavaScript and React**  
https://github.com/microsoft/react-native-windows  
A framework for building native Windows apps with React. 这是要和 Flutter 竞争吗.

**Dark Mode Support in WebKit**  
https://webkit.org/blog/8840/dark-mode-support-in-webkit/  
With the Safari 12.1 update in macOS 10.14.4, dark mode support in WebKit has arrived. 另附：[Technical Details on the Recent Firefox Add-on Outage](https://hacks.mozilla.org/2019/05/technical-details-on-the-recent-firefox-add-on-outage/)、

**Ionic Release: 4.4.0**  
https://blog.ionicframework.com/ionic-release-4-4-0-beryllium/  
We’re happy to share that Ionic 4.4.0 (Beryllium) is available today 🎉. This release includes some new features, so let’s dive right in.

**SQLite compiled to javascript**  
https://github.com/kripken/sql.js  
sql.js is a port of SQLite to Webassembly, by compiling the SQLite C code with Emscripten. It uses a virtual database file stored in memory, and thus doesn't persist the changes made to the database. 另附：[rqlite - an easy-to-use, lightweight, distributed relational database](https://github.com/rqlite/rqlite)

**Comlink**  
https://github.com/GoogleChromeLabs/comlink  
Comlink makes WebWorkers enjoyable. Comlink is a tiny library (1.1kB), that removes the mental barrier of thinking about postMessage and hides the fact that you are working with workers.

**Tippy.js - Vanilla JS Tooltip and Popover Library**  
https://atomiks.github.io/tippyjs/  
Tippy.js is a highly customizable tooltip and popover library powered by Popper.js. It's compatible with IE11+, about 99% of desktop users and 97% of mobile users. It can be used to create simple static text tooltips, or complex HTML popovers that utilize AJAX.

**CSSFX - Beautifully simple click-to-copy CSS effects**  
https://cssfx.dev/  
A carefully crafted collection designed with a focus on fluidity, simplicity, and ease of use. Powered by CSS with minimal markup. Completely open source and MIT licensed.

**CSS-Only Chat**  
https://github.com/kkuchta/css-only-chat  
A truly monstrous async web chat using no JS whatsoever on the frontend.

**Low.js - Node.js for microcontrollers**  
https://www.lowjs.org/  
low.js is a port of the JavaScript runtime Node.js with far lower system requirements, allowing it to run on cheap, power-efficient microcontroller boards based on the ESP32-WROVER module. With low.js you can build scalable Internet-native electronics applications (IoT) easily and fast.

**Node-convict**  
https://github.com/mozilla/node-convict  
Convict expands on the standard pattern of configuring node.js applications in a way that is more robust and accessible to collaborators, who may have less interest in digging through imperative code in order to inspect or modify settings. By introducing a configuration schema, convict gives project collaborators more context on each setting and enables validation and early failures for when configuration goes wrong.

**sitemap.js**  
https://github.com/ekalinin/sitemap.js  
sitemap.js is a high-level sitemap-generating framework that makes creating [sitemap XML](https://www.sitemaps.org/index.html) files easy.

**dotenv**  
https://github.com/motdotla/dotenv  
Dotenv is a zero-dependency module that loads environment variables from a .env file into process.env. Storing configuration in the environment separate from code is based on The Twelve-Factor App methodology.

**JMAP: A modern, open email protocol**  
https://www.ietf.org/blog/jmap/  
The new JMAP protocol addresses shortcomings of previous open protocols connecting email clients and servers were not designed for the modern age. JMAP is the result of efforts to address shortcomings, providing a modern, efficient, easy-to-use API, built on many years of experience and field testing.

## 设计

**Is Your Team Ready for the Future of Design Systems?**  
https://blog.framer.com/is-your-team-ready-for-the-future-of-design-systems-4cc86fc5654  
A guide on how to bring your production components into Framer X and share it with the rest of your team, so everything is in sync.

**Designing Sound and Silence**  
https://medium.com/google-design/designing-sound-and-silence-1b9674301ec1  
At Google, we’ve put together our learnings on sound design for anyone to apply, in the first-ever [Material Sound guidelines](https://material.io/design/sound/about-sound.html). These guidelines provide best practices for how we use — and don’t use — sound to create experiences that feel like a natural part of the product, enhance user interactions, and contextually grab the listener’s ear. 另附：[QQ 8.0语音消息改版设计策划故事](https://mp.weixin.qq.com/s?__biz=MjM5NzQxMDkwMg==&mid=2655408121&idx=1&sn=ada533009f3d74085f443b28aee9dc42).

**How to Design Effective Infographics?**  
https://uxplanet.org/infographic-design-26dad026bbdd  
An infographic is a visual representation of a story. You have something to tell your audience, infographics provide you a way of presenting the information more effectively. Though writing large articles with lot of textual content has its own importance, infographic is another way to show difficult concepts in a simpler form.

**Trans-inclusive Design**  
https://alistapart.com/article/trans-inclusive-design/  
We are web professionals; we can do better than an offline workaround. The choices we make impact the online and offline experiences of real people who are trans, non-binary, or gender-variant—choices that can affirm or exclude, uplift or annoy, help or harm. The rest of this article assumes you agree with the concept that trans people are human beings who deserve dignity, respect, and care.

**Lessons on Visualization from the Industrial Environment**  
https://www.uxmatters.com/mt/archives/2019/05/lessons-on-visualization-from-the-industrial-environment.php  
Making a user interface beautiful does not necessarily mean adding rich graphics or eye-popping colors. There is beauty in simplicity. Moreover, users do not view a data visualization for the sake of admiring its aesthetics, but to get answers to their top-of-mind questions. Viewing an effective visualization should be like receiving a report from a trusted confidant that clearly answers the users’ questions in a way that does not further burden them.

## 产品及其它

**Inside Microsoft’s surprise decision to work with Google on its Edge browser**  
https://www.theverge.com/2019/5/6/18527550/microsoft-chromium-edge-google-history-collaboration  
The story behind how Microsoft made “that monumental decision” to use Chromium as the new foundation for their browser.

**想知道历史上的今天发生了什么？让「全历史」告诉你**  
https://sspai.com/post/54567  
全历史 App 里没有枯燥无味的论文，也没有刻意吸引眼球的标题。你可以在应用首页读到生动有趣文章的同时，学到更多历史知识，你也可以尝试应用中像时间地图、关系图谱等各种特色功能，亲自探寻感兴趣的历史事件。

**知乎之死：是谁先动的手**  
https://mp.weixin.qq.com/s/Bz8gzhkUShcT0k-mKPG6dQ  
人们天生喜欢看强者被弱者打败，喜欢看恶龙被勇士屠杀，在这个过程中甚至人们会帮助勇士铸剑。人们厌恶微博广告的无孔不入，希望新生力量可以打败旧势力。人们希望看到微博被挑战者知乎打败。如今，知乎独自周旋许久。和自己的大V斗智斗勇，用自己的技术建墙又拆墙。

**美国人眼中的中国崛起 | 哈佛教授TED演讲**  
https://mp.weixin.qq.com/s?__biz=MjM5NDI2NDU5Mw==&mid=2655261254&idx=1&sn=8c5570f435df245ae29e56b57347e294  
格雷厄姆·埃里森多次到访中国，对中国的发展和崛起有着深入的研究，并一直致力于探讨和解决中美之间如何避免修昔底德陷阱。下面，是格雷厄姆·埃里森教授2018年9月在TED上的演讲视频和双语对照全文，对于美国人眼中的中国崛起究竟是什么样的问题，让我们一起来聆听他的独到见解。

> 对数据可视化有兴趣的可以阅读由 AntV 带来的 [墨者修齐 2019-05-13·经济学人也犯过的错、可视化诺贝尔奖提名、关于时间的地图](https://www.yuque.com/mo-college/weekly/twblys)  

-- THE END --