---
layout: post
title: 'FEX 技术周刊 - 2020/02/10'
author: wuyiping
tag: weekly
---


## 深阅读

**Old CSS, new CSS**  
https://eev.ee/blog/2020/02/01/old-css-new-css/  
I first got into web design/development in the late 90s, and only as I type this sentence do I realize how long ago that was. And boy, it was horrendous. I mean, being able to make stuff and put it online where other people could see it was pretty slick, but we did not have very much to work with. I’ve been taking for granted that most folks doing web stuff still remember those days, or at least the decade that followed, but I think that assumption might be a wee bit out of date. Some time ago I encountered a tweet marvelling at what we had to do without border-radius. I still remember waiting with bated breath for it to be unprefixed! But then, I suspect I also know a number of folks who only tried web design in the old days, and assume nothing about it has changed since. I’m here to tell all of you to get off my lawn. Here’s a history of CSS and web design, as I remember it. 另附：[CSS4 is a Bad Idea](https://www.impressivewebs.com/css4-bad-idea/).

**What is SAP**  
https://retool.com/  
https://retool.com/blog/erp-for-engineers/  
ERP is where companies store their core operational data. We’re talking about sales projections, purchase orders, and inventory, as well as the processes that act upon that data (e.g. paying out vendors when a purchase order is issued). In a sense, ERP is the “brain” of a company — it stores all important pieces of data and all of the actions possible in data-driven workflows. But before taking over the modern business world, how did ERP software get started? The story of ERP begins with major automation efforts of the 1960s: while the 1940s and 50s were focused on mechanical automation of blue collar work — think General Motors establishing their automation department in 1947 — the automation of white collar work (often via the computer!) began in the 1960s.

**Webix - Declarative UI Framework for Rapid Development - Interview with Maksim Kozhukh**  
https://survivejs.com/blog/webix-interview/  
If there's something that has changed during the past few years, it's the way we develop user interfaces using JavaScript. Earlier we've learned about solutions, such as Reakit. Now it's time to look into a library designed especially for rapid prototyping. I'm interviewing Maksim Kozhukh from Webix to learn more about their approach.

**Understanding the ECMAScript spec, part 1**  
https://v8.dev/blog/understanding-ecmascript-part-1  
In this article, we take a simple function in the spec and try to understand the notation. 另附：[Ecma TC39 JavaScript Decimal proposal](https://github.com/littledan/proposal-decimal).

**Version 9 of Angular Now Available — Project Ivy has arrived!**  
https://blog.angular.io/version-9-of-angular-now-available-project-ivy-has-arrived-23c97b63cfa3  
The 9.0.0 release of Angular is here! This is a major release that spans the entire platform, including the framework, Angular Material, and the CLI. This release switches applications to the Ivy compiler and runtime by default, and introduces improved ways of testing components

**前端微服务在字节跳动的打磨与应用**  
https://mp.weixin.qq.com/s/iLdAH9p2-S8pFyZrNzYaNg  
本文讨论了微前端在字节跳动的应用情况，内容主要分析了微前端具体落地的步骤和两年来的使用情况。其中分析的部分主要讲到一些实际问题和我们的应对，落地情况强调了实现的过程。特别讲到很多在我们观念里面务必要提供的微前端基石，这些方面作为基础设施几乎是使用微前端的必要和前提条件。

**前端的守望者：阿里岳鹰 Web 全景监控平台的建设之路**  
https://mp.weixin.qq.com/s?__biz=MzUxMzcxMzE5Ng==&mid=2247493710&idx=1&sn=ee45b6127e610b63407f1c2399060081  
线上监控作为产品质量的最后一道屏障，其意义和影响都十分重大。阿里岳鹰团队从内部业务痛点出发，沉淀了一套 Web 前端全景监控方案。在监控方面，实现了常规的 JS 异常、资源加载异常、页面性能以及接口请求监控，并且支持自定义上报，以满足全链路中更多的场景。同时，团队联合 UC 浏览器内核团队，独创了基于 V8 的“页面白屏”监控。在问题分析和解决方面，打造了一套高效的问题分析和智能预警体系。

**Micro-Frontend Composition Patterns**  
https://medium.com/better-programming/micro-frontend-composition-patterns-9b789c0dad81  
Design patterns to help you build micro frontends effectively.

**Does your web app need a front-end framework?**  
https://stackoverflow.blog/2020/02/03/is-it-time-for-a-front-end-framework/  
You’ve likely heard about front-end frameworks. Names like React, Vue, and Angular abound in tutorials and Hacker News debates. If you’ve wondered why and when these frameworks are used and whether it’s time you implement one in your project, you’re not alone. A few years ago, while working on a side project, Hackterms, my own...

**You don't (may not) need Moment.js**  
https://github.com/you-dont-need/You-Dont-Need-Momentjs  
Moment.js is a fantastic time & date library with lots of great features and utilities. However, if you are working on a performance sensitive web application, it might cause a huge performance overhead because of its complex APIs and large bundle size.

**Redesign: Gridniking**  
https://frankchimero.com/blog/2020/gridniking/  
Making grids sits somewhere between sharpening axes and solving puzzles, part prep work, part game. Some designers are obsessed with grids, and I can understand the appeal. There are enough details that you can get lost in it, and what you produce becomes a tool, an investment. Dividing space is indeed one of the principle tasks of design, and grids offer a way to structure that work. All the same, designs placed on super intricate grid systems can feel a little…sterile? Micromanaged? Over-built? Those aren’t quite the right words, but I think you know what I mean. There is a point where a grid system becomes too elaborate and loses its finesse. The structures that are meant to support creative choices can become a cage. I’m a big proponent of “just enough grid.” Grids are scaffolding, structures meant to help get the main building done. There is no need to overbuild, especially for this site. I am going to stay organized, but only just so.

**The State of Serverless - Datadog**  
https://www.datadoghq.com/state-of-serverless/  
“Serverless” may be a buzzword, but it's not an empty one. Less than five years since it launched, AWS Lambda has already been adopted by nearly half of companies with infrastructure in AWS. In this report, we examine the serverless usage of thousands of companies to provide a look at how (and how much) serverless is being used in the real world.

**Why Choose Flutter in 2020?**  
https://levelup.gitconnected.com/why-choose-flutter-in-2020-22d87e60200a  
It’s as good as everyone says, but even better

**Things I Believe About Software Engineering**  
https://blog.wesleyac.com/posts/engineering-beliefs  
Inspired by [Jan Stette's "Things I Believe" post](https://gist.github.com/stettix/5bb2d99e50fdbbd15dd9622837d14e2b), I decided to write down some of the more contentious beliefs I have about software engineering. I've selected some of my more extreme opinions here, so I expect reasonable people to disagree with me. 

**FLIF - Free Lossless Image Format**  
https://flif.info/  
FLIF is a novel lossless image format which outperforms PNG, lossless WebP, lossless BPG, lossless JPEG2000, and lossless JPEG XR in terms of compression ratio.

**A new hash algorithm for Git**  
https://lwn.net/SubscriberLink/811068/cfeb6a67b8dfbe47/  
The Git source-code management system is famously built on the SHA‑1 hashing algorithm, which has become an increasingly weak foundation over the years. SHA‑1 is now considered to be broken and, despite the fact that it does not yet seem to be so broken that it could be used to compromise Git repositories, users are increasingly worried about its security. The good news is that work on moving Git past SHA‑1 has been underway for some time, and is slowly coming to fruition; there is a version of the code that can be looked at now.

**Why Discord is switching from Go to Rust**  
https://blog.discordapp.com/why-discord-is-switching-from-go-to-rust-a190bbca2b1f  
Rust is becoming a first class language in a variety of domains. At Discord, we’ve seen success with Rust on the client side and server side. For example, we use it on the client side for our video encoding pipeline for Go Live and on the server side for Elixir NIFs. Most recently, we drastically improved the performance of a service by switching its implementation from Go to Rust. This post explains why it made sense for us to reimplement the service, how it was done, and the resulting performance improvements. 

**The Zen of Go**  
https://the-zen-of-go.netlify.com/  
Ten engineering values for writing simple, readable, maintainable Go code. 

**The best AI programming languages to use**  
https://algorithmia.com/blog/the-best-ai-programming-languages-to-use  
Computer coding must be involved to implement any type of AI system, and there is a variety of programming languages that lend themselves to specific AI or machine learning tasks. Let’s look at which programming languages will be the most beneficial for your specific use cases. We have composed a simple list showing which five programming languages are best to learn if you want to be successful in the artificial intelligence industry. Each has its own particular strengths and weaknesses for a given project, so consider your end goals before selecting a language.

## 新鲜货

**Electron 8.0.0**  
https://www.electronjs.org/blog/electron-8-0  
Electron 8.0.0 has been released! It includes upgrades to Chromium 80, V8 8.0, and Node.js 12.13.0. We've added Chrome's built-in spellchecker, and much more!

**Chrome v80 release: JS module support for workers**  
https://codeburst.io/chrome-v80-release-js-module-support-for-workers-a4a9397d194b  

**A Day in the Life of npm Security**  
https://blog.npmjs.org/post/190665497245/a-day-in-the-life-of-npm-security  
The JavaScript ecosystem is a lush, fertile, mostly beneficent garden. But even the best gardens need some tending. Much of that tending comes in the form of the continuous research on the part of the npm security team mated with their automated processes behind the scenes at npm, Inc. when new packages are published. Another crucial element is the vigilance of the JavaScript community at large looking for and reporting potential vulnerabilities of packages in the registry. The net effect of this widely-scoped vigilance is an inbox chock full of vulnerability reports that must be addressed every day.

**Announcing Ionicons 5**  
https://ionicframework.com/blog/announcing-ionicons-5/  
I’m excited to announce version 5 of Ionicons, a hand-crafted set of premium open source icons for use across web, iOS, Android, and desktop apps. Ionicons 5 builds on our previous Web Component icon foundation, bringing over 1200 icons and a totally new design approach.

**Introducing Neo4j Graph Database 4.0 [GA Release]**  
https://neo4j.com/blog/neo4j-graph-database-4-0-ga-release/  
Neo4j 4.0 is the culmination of more than a year’s worth of our work, from the biggest engineering team ever invested in graph technology. To put that in more developer-friendly terms, we’ve invested around a century’s worth of human effort into this release.

**20+ Web Projects With Vanilla JavaScript**  
https://github.com/bradtraversy/vanillawebprojects  
Mini projects built with HTML5, CSS & JavaScript. No frameworks or libraries.

**React Libraries in 2020**  
https://www.robinwieruch.de/react-libraries  
React only enables you to build component driven user interfaces with function components and props. It comes with a couple of built-in solutions though, for instance, React Hooks for local state and side-effects. But after all you are only dealing with components here. The following article will give you an opinionated approach to select from complementary libraries to build a well-rounded React application. It's up to you to exchange them with your choices. 另附：[React v6.0.0-alpha](https://github.com/ReactTraining/react-router/releases/tag/v6.0.0-alpha.0).

**gltfjsx**  
https://github.com/react-spring/gltfjsx  
Turns GLTF's into JSX components.

**Remirror**  
https://docs.remirror.org/  
React + Prosemirror + Emotion + Typescript = Love . A world class text editor toolkit for every environment.

**Structured text tools**  
https://github.com/dbohdan/structured-text-tools  
The following is a list of text-based file formats and command line tools for manipulating each.

**The Missing Semester of Your CS Education**  
https://missing.csail.mit.edu/  
Classes teach you all about advanced topics within CS, from operating systems to machine learning, but there’s one critical subject that’s rarely covered, and is instead left to students to figure out on their own: proficiency with their tools. We’ll teach you how to master the command-line, use a powerful text editor, use fancy features of version control systems, and much more! Students spend hundreds of hours using these tools over the course of their education (and thousands over their career), so it makes sense to make the experience as fluid and frictionless as possible. Mastering these tools not only enables you to spend less time on figuring out how to bend your tools to your will, but it also lets you solve problems that would previously seem impossibly complex.

**Sandstorm**  
https://sandstorm.io/  
https://sandstorm.io/news/2020-02-03-reviving-sandstorm  
Self-host web-based productivity apps easily and securely. Sandstorm is an open source project built by a community of volunteers with the goal of making it really easy to run open source web applications -- either on your own private server, or on our community-run servers. 
理念很好：Sandstorm is on a mission: to make open source and indie web applications viable as an ecosystem

**Game AI Pro 3**  
http://www.gameaipro.com/  
All book chapters are free to download. The third volume in the Game AI Pro book series (published June 2017).

## 设计

**404 Page: Design Not Found. How to Create Great Error Pages**  
https://uxplanet.org/404-page-design-not-found-how-to-create-great-error-pages-cfc43c4fa95f  
A designer is able to produce a creative 404 error page to raise your conversion rate and increase traffic, turning passers-by into leads. If you’re on the lookout for some inspiration on how to improve your website’s 404 page (with examples), then read on!

**Here Are All The New Emojis Coming In 2020**  
https://theultralinx.com/2020/02/here-are-all-the-new-emojis-coming-in-2020/  
The Unicode Consortium has revealed its list of new emojis for 2020 including a smiling tear face, a pinched hand, ninjas, and a whole lot more. There will also be numerous gender-inclusive emojis included in the update.

**From Sony to Bytedance, what I learned from my four UX internships**  
https://blog.prototypr.io/from-sony-to-bytedance-what-have-i-learned-from-my-past-four-ux-internships-f7b1f9b438ef  
As students, most of us are going to graduate and step into the working environment sooner or later. I believe that knowing how professionals work in advance will make us more prepared and confident when our day finally comes. Thus, I wrote down some of the takeaways I had from my experiences, and I hope that will help you all prepare too.

**Everything About Usability Testing Through Al-Powered Software**  
https://www.uxpin.com/studio/blog/everything-about-usability-testing-through-al-powered-software/  
Are you a professional designer or developer? Are you an online business enthusiast? How much do you know about Artificial Intelligence? Why is AI now more feasible and critical than ever? How is AI best applied, and how can AI help us test smarter? How is AI changing user research? How do you leverage Al in software testing? 

**Meet “The Ethical Design Handbook”: How To Leave Dark Patterns Behind**  
https://www.smashingmagazine.com/2020/02/ethical-design-handbook-prerelease/  
Meet our new practical guide on how to influence a positive change in your company and help your business grow sustainably. Without dark patterns, with ethics in mind, and ready for GDPR and CCPA. 

## 产品及其它

**都 2020 年了，你还在用邮件交周报吗？**  
https://www.yuque.com/yuque/blog/gi4l0c  
对，说的就是你，都 2020 年了，你还在用邮件交周报吗？几周前的周报沉没在收件箱里找不到？团队同学一多就看不出来谁提交了谁没提交？团队周报写完就完没沉淀下来？快来试试语雀话题知识库吧~~~语雀话题知识库全新发布，专为解决日报周报各种疑难杂症！

**估值 30 亿美元，连续 15 年纯远程办公，这家公司做对了什么？**  
https://mp.weixin.qq.com/s/Ju547qIG8s5FLet4lYwI8Q  
Automattic 是一家神奇的公司。多数人对它并不了解，但其旗下的两款主要产品 WordPress 与 Tumblr 却广为人知。Matt Mullenweg 在 2005 年以个人博客系统 WordPress 起家，并创立了 Automattic。经过 15 年的攻城掠寨之后，目前，全世界的网站中 由 WordPress 驱动的，月覆盖人数达到谷歌的 60%。2019 年 9 月份，Automattic 收购了拥有 1.3 亿用户的轻博客网站 Tumblr。在同年 11 月，Automattic 完成来自 Salesforce 的 3 亿美元的 D 轮融资，估值达到 30 亿美元。公司员工也由最初的 1 个人，发展到了 1100 人，分布在全世界 75 个国家。有趣的是，在扩张、发展过程当中，这家公司一直采用纯远程办公的方式。Automattic 并不是远程办公的开创者，但它用自身的业绩击破了对这种办公方式的种种质疑，并成为了远程办公的重要布道者。


> 对数据可视化有兴趣的可以阅读由 AntV 带来的 [墨者修齐 2020-02-09 · 基于社区发现算法和图分析Neo4j解读《权力的游戏》、巴黎永不眠、FlowingData Best Data Visualization、情绪可视化、描述“好”的单词有多“好”、DOMO 的图表知识库](https://www.yuque.com/mo-college/weekly/aveo00)

-- THE END --
