---
layout: post
title: "FEX 技术周刊 - 2020/04/06"
author: zhangjunah
tag: weekly
---

2020.04.06 - Robots Learning to Move like Animals  
========  

## 深阅读 

**Robots Learning to Move like Animals**  
https://bair.berkeley.edu/blog/2020/04/03/laikago/  
In this work, we present a framework for learning robotic locomotion skills by imitating animals. Given a reference motion clip recorded from an animal (e.g. a dog), our framework uses reinforcement learning to train a control policy that enables a robot to imitate the motion in the real world.  另附：[Exploring Nature-Inspired Robot Agility](https://ai.googleblog.com/2020/04/exploring-nature-inspired-robot-agility.html).

**ECMAScript 2020: The Final Feature Set**  
https://pawelgrzybek.com/whats-new-in-ecmascript-2020/  
https://2ality.com/2019/12/ecmascript-2020.html
TC39 has just approved the [ECMAScript 2020 spec](https://tc39.es/ecma262/2020/) (a full weekend's bedtime reading right there!) with Ecma GA approval due in a few months, but what’s new?

**Pointer Compression in V8**  
https://v8.dev/blog/pointer-compression  
There is a constant battle between memory and performance. As users, we would like things to be fast as well as consume as little memory as possible. Unfortunately, usually improving performance comes at a cost of memory consumption (and vice versa).

**Introducing Microsoft Editor – Bring out your best writer wherever you write**  
https://techcommunity.microsoft.com/t5/microsoft-365-blog/introducing-microsoft-editor-bring-out-your-best-writer-wherever/ba-p/1247931  
With the power of AI, we are bringing the Microsoft Editor experience to all the places you write, meeting you where you are, and helping you to easily bring out your best writer. No matter what language you are writing in, we have you covered. It is all part of our broader vision for Microsoft 365, a productivity experience that puts AI to work for you. Over time, Microsoft Editor will evolve, becoming more helpful and accurate as we incorporate feedback from our customers to make improvements. Microsoft Editor will begin rolling out today, with general availability by the end of April. Office 365 will become Microsoft 365 beginning April 21.

**Innovating on Web Monetization: Coil and Firefox Reality**  
https://hacks.mozilla.org/2020/03/web-monetization-coil-and-firefox-reality/  
In the coming weeks, Mozilla will roll out a Web Monetization experiment using Coil to support payments to creators in the Firefox Reality ecosystem. Web Monetization is an alternative approach to payments that doesn’t rely on advertising or stealing your data and attention. We wrote about Web Monetization for game developers back in the autumn, and now we’re excited to invite more of you to participate, first as creators and soon as consumers of all kinds of digital and virtual content.

**Modern UX metrics on WebPageTest**  
https://addyosmani.com/blog/modern-ux-metrics-on-webpagetest/  
https://addyosmani.com/blog/pagespeed-insights-api/  
This tip covers how to measure modern UX metrics on WebPageTest using the Custom Metrics feature. On the Chrome team, we've recently been looking at a few new metrics we believe help better quantify what makes for a good user-experience on the web. 

**如何用 DDD 结合 TDD 的思想『分治』复杂问题**  
https://mp.weixin.qq.com/s?__biz=MjM5Mjg4NDMwMA==&mid=2652977366&idx=1&sn=a39a769f8dce2bec261f1a2061a15b9f  
软件开发是一项复杂的集体活动，它涉及到一系列的行为和艺术，如项目管理、流程管控、知识转化、程序员心理学（狗头）等。从个体出发时，这些都是一些无关紧要的因素。作为一个 “螺丝钉”，我们所关心的是：如何去解决问题？当然了，我们把组织视为一个个体时，我们也只关心：如何去解决问题？本文是我在写 Chapi 过程中的一个感悟与过程的思考，因为它具有一定的代表性，所以记录一下供大家参考。

**[译]无代码开发，站到了程序员鄙视链顶端**  
https://mp.weixin.qq.com/s/wcwpxY054VJtKVXLtkM32A  
微软称无代码是它的“Next Big Thing”，谷歌说无代码是下一代的变革和提升。也有越来越多的企业开始进入“无代码”领域。这是在革开发者的命吗？你可能多虑了。所谓“无代码”，并不是“不存在代码”，无代码平台的开发对后台的支撑能力提出了更高的要求，需要更为强大的技术团队。所以“无代码”不是在"淘汰”开发者，而是给予开发者更大挑战、更多机会。

**I Am Switching to JS**  
https://blogtitle.github.io/i-am-switching-to-js/  
After 5 years of using Go I am finally moving on. Go has served me well and has been the best language I could have possibly used for the longest time, but it is now the moment for me to let it Go. 

**Is Apple trying to kill PWAs?**  
https://ionicframework.com/blog/is-apple-trying-to-kill-pwas/  
It seems that any time Apple releases something there is bound to be some noise regarding it. This time, it’s in regards to browser storage and Apple’s recent proclamation that such data will be deleted after 7 days. Well let’s break this down and see what this really means for developers.

**33 line React**  
https://leontrolski.github.io/33-line-react.html  
In this post, I'm going to make the smallest React-like thing that can do the above. It's very mithril influenced.

**Introducing React Easy State by RisingStack**  
https://blog.risingstack.com/introducing-react-easy-state-risingstack/  
React Easy State is a transparent reactivity based state manager. It automagically decides when to render which components without explicit orders from you.

**What Should You Do When A Web Design Trend Becomes Too Popular?**  
https://www.smashingmagazine.com/2020/03/web-design-trend-popular/  
By now, you’re probably used to seeing design trends come and go. But have you ever given any thought to what passing trends do to a website when left there for too long? As a web designer, you have a few choices. You can ignore popular design trends altogether; you can adopt them, but pull them out of rotation the second they go stale, or you can put your own unique spin on them. This guide will help you figure out which approach makes the most sense for your site.

**Running Golang on the browser with WebAssembly and TinyGo**  
https://marianogappa.github.io/software/2020/04/01/webassembly-tinygo-cheesse/  
This is the story of how I managed to expose my Golang chess API project cheesse as a WebAssembly binary, compiled using TinyGo, so JavaScript could use it without needing a server. The blogpost is optimised for helping others going through a similar exercise, rather than for readability, so expect a little too much of “if this, do this”. Sorry.

**Hapi: A Performance deep-dive**  
https://www.nearform.com/blog/hapi-a-performance-deep-dive/  
https://hapi.dev/  
Recently we were tasked with investigating performance with the popular web framework hapi. Performance means a lot of different things, but we wanted to see if we could improve the requests per seconds that hapi could perform on real-world use cases. Real-world means not just “juicing” the stats to improve various benchmark scores but actually trying to figure out what kind of bottlenecks appeared when using the framework for the application you’d normally do when writing an application deployed for a wider audience.

**How Flutter led me to React Native — and vice-versa**  
https://medium.com/flutter-community/how-flutter-led-me-to-react-native-and-vice-versa-7f8fc77ff295  
The experience of small teams with both tools and the decisions we made aiming for better user experience in 2017 and 2020. 另附：[Why Flutter Has Become the Best Choice To Develop a Startup Mobile App in 2020?](https://medium.com/flutter-community/why-flutter-has-become-the-best-choice-to-develop-a-startup-mobile-app-in-2020-5785ea153b13), [Flutter web: Navigating URLs using named routes](https://medium.com/flutter/flutter-web-navigating-urls-using-named-routes-307e1b1e2050), [flutter: 一周感悟](https://mp.weixin.qq.com/s/nBkcDaKkBxTL-rhKfAhLMg).

**Serverless Patterns**  
https://medium.com/@taibi.davide/serverless-patterns-e1fb3f1d753e  
Among 24 selected works, we identified 32 patterns that we classified as orchestration, aggregation, event-management, availability, communication, and authorization. In this post, we summarize the patterns identified, together with their benefits and issues.

**Puppeteer or: How I Learned to Stop Worrying and Love the Automation**  
https://itnext.io/puppeteer-or-how-i-learned-to-stop-worrying-and-love-the-automation-92e96f4901e7  
A step by step guide for beginners to get started with Puppeteer.

**A 10-Year-Old’s Perspective on Computer Programming**  
https://medium.com/better-programming/a-10-year-olds-perspective-about-computer-programming-c8556a9cb747  
Let’s talk about coding!

**We released simdjson 0.3: the fastest JSON parser in the world is even better!**  
https://lemire.me/blog/2020/03/31/we-released-simdjson-0-3-the-fastest-json-parser-in-the-world-is-even-better/  
Last year (2019), we released the simjson library. It is a C++ library available under a liberal license (Apache) that can parse JSON documents very fast. How fast? We reach and exceed 3 gigabytes per second in many instances. It can also parse millions of small JSON documents per second. The new version is much faster. How much faster? Last year, we could parse a file like simdjson at a speed of 2.0 GB/s, and then we reached 2.2 GB/s. We are now reaching 2.5 GB/s. Why go so fast? In comparison, a fast disk can reach  5 GB/s and the best network adapters are even faster.

**Bringing 4K and HDR to Anime at Netflix with Sol Levante**  
https://netflixtechblog.com/bringing-4k-and-hdr-to-anime-at-netflix-with-sol-levante-fa68105067cd  
Some might dismiss them as simple cartoons, but anime’s diverse and fantastical stories, vibrant style, and delicate lines are an art form that has evolved and grown in popularity, variety and sophistication over the last fifty years. From its likely roots in colorful painted lanterns in the early 20th century, to gaining mainstream status in Japan in the 1970s, viewers now have hundreds of anime series and films to choose from all over the world.

**An Architecture for a Multilingual Wikipedia**  
http://simia.net/download/multilingualwikipedia.pdf  
An interesting paper from the creator of Wikidata that proposes a way to architect an ‘abstract’ Wikipedia where content can be rendered down into multiple languages as necessary. There’s a lot to chew on here.

**How are Unix pipes implemented?**  
https://toroid.org/unix-pipe-implementation  
This article is about how pipes are implemented the Unix kernel. I was a little disappointed that a recent article titled “How do Unix pipes work?” was not about the internals, and curious enough to go digging in some old sources to try to answer the question.

**How we reduced our Google Maps API cost by 94%**  
https://blog.cityflo.com/how-we-reduced-our-google-maps-api-cost/  
Being a highly reliable commute partner for our customers, we at Cityflo ensure high accuracy and predictability of our vehicle tracking system. Showing an accurate arrival time to our users is a big contributor to the experience that our users expect from us.

**Tech Debt and the Pragmatic Middle Ground**  
https://blog.pragmaticengineer.com/tech-debt/  
Blissful unawareness, denial, then acceptance, then resistance. And finally, a pragmatic middle ground. This is the typical journey engineers go through in their relationship with tech debt.

## 新鲜货  

**Open Access to ACM Digital Library During Coronavirus Pandemic**  
https://www.acm.org/articles/bulletins/2020/march/dl-access-during-covid-19  
We believe that ACM can help support research, discovery and learning during this time of crisis by opening the ACM Digital Library to all. For the next three months, there will be no fees assessed for accessing or downloading work published by ACM. We hope this will help researchers, practitioners and students maintain access to our publications as well as increasing visibility and awareness of ACM’s journals, proceedings and magazines. Please be sure to inform your colleagues that the ACM DL is now open, and will continue that way through June 30, 2020.

**18 GitLab features are moving to open source**  
https://about.gitlab.com/blog/2020/03/30/new-features-to-core/  
We're open sourcing rich functionality across Plan, Create, Verify, Package, Release, Configure, and Defend.

**Happy 404 Day!**  
http://blog.archive.org/2020/03/30/happy-404-day-%ef%bb%bf/
Saturday is April 4th (4/04), and here at the Internet Archive we’re marking a new holiday: 404 Day! We’re using this date to celebrate the work that’s being done to end the dreaded 404 error, record changing webpages, and preserve the internet for all to enjoy. We spoke with Gary Price—librarian, editor of InfoDocket, and a prolific user of the Wayback Machine—about why web archiving is important and how ordinary people can fight back against “link rot.” 

**OpenTelemetry is now beta!**  
https://opensource.googleblog.com/2020/03/opentelemetry-is-now-beta.html  
[OpenTelemetry](https://github.com/open-telemetry/) and OpenCensus have been a critical part of our goal of making platforms like Kubernetes more observable and more manageable. This has been a multi-year journey for us, from creating OpenCensus and growing it into a core part of major web services’ observability stack, to our announcement of OpenTelemetry last year and the rapid growth of the OpenTelemetry community.

**Element Timing API - Draft Community Group Report**  
https://wicg.github.io/element-timing/#sec-example  
Knowing when critical elements are displayed on screen is key to understanding page load performance. While fast rendering of the essential components is not sufficient for a satisfactory loading experience, it is necessary. Therefore, monitoring these rendering timestamps is important to improve and prevent regressions in page loads. This specification gives developers and analytics providers an API to measure rendering timestamps of critical elements. There is currently no good way to measure these timestamps for real users. Existing approaches would require either registering observers too early or significant DOM manipulation. These approaches are discussed on the § 4 Security & privacy considerations section.

**WebTransport Draft Community Group Report**  
https://wicg.github.io/web-transport/  
This document defines a set of ECMAScript APIs in WebIDL to allow data to be sent and received between a browser and server, implementing pluggable protocols underneath with common APIs on top. APIs specific to QUIC are also provided. This specification is being developed in conjunction with a protocol specification developed by the IETF QUIC Working Group.

**Node 14.0.0 Release Candiate 1**  
https://nodejs.org/download/rc/v14.0.0-rc.1/  
Final release of 14 as the new ‘current’ release is due in a few weeks and we’ll feature it again then. Node 14 should then become LTS in October.

**The Eclipse Foundation Releases Eclipse Theia 1.0, a True Open Source Alternative to Visual Studio Code**  
https://github.com/eclipse-theia/theia  
能复用 VS Code 的扩展

**TypeScript2Cxx**  
https://github.com/ASDAlexander77/TypeScript2Cxx  
TypeScript to C++

**KendoReact - UI for React Developers**  
https://www.telerik.com/kendo-react-ui/  
Building UI for business apps is hard work, even with React. Make it easy with our native UI & data visualization component library.

**Announcing “use-sound”**  
https://joshwcomeau.com/react/announcing-use-sound-react-hook/  
A React Hook for Sound Effects

**Trianglify**  
https://github.com/qrohlf/trianglify  
Algorithmically generated triangle art.

**More Toggles.css**  
https://jnkkkk.github.io/MoreToggles.css/  
A Pure CSS library that provides you with stylish toggles.

**WebdriverIO v6 Released**  
https://webdriver.io/blog/2020/03/26/webdriverio-v6-released.html  
This major update is far less "breaking" than the one last year. While all the architectural changes last year left us no choice to break a lot of things, we were very careful this time and made sure that upgrading the framework won't become a big task. This major update is much more reasonable and contains subtle changes that will help the project further grow while remaining performant at the same time. This blog post will go into details about all major changes and will explain what you need to do to transition from v5 to the v6.

**Writing an OS in Rust**  
https://os.phil-opp.com/  
This blog series creates a small operating system in the Rust programming language. Each post is a small tutorial and includes all needed code, so you can follow along if you like. The source code is also available in the corresponding [Github repository](https://github.com/phil-opp/blog_os).

**Prisma 2.0 is Now in Beta: Type-safe Database Access with Prisma Client**  
https://www.prisma.io/blog/prisma-2-beta-b7bcl0gd8d8e  
Prisma is an open-source database toolkit. It replaces traditional ORMs and makes database access easy with an auto-generated query builder for TypeScript & Node.js.

**From Markdown to Video**  
https://www.videopuppet.com/docs/script/  
Video Puppet makes it easy to script videos using plain text (Markdown) files. You can use Markdown, YAML or JSON format to create the script. We recommend using Markdown for manually created files (as it’s human-friendly), and JSON or YAML for automatically created script files (more machine-friendly). When working with Markdown files, make sure to name the file so it has the .md or .mkd file extension. 另附：[OBS Studio - Free and open source software for video recording and live streaming](https://obsproject.com/).

**Dolt Use Cases**  
https://www.dolthub.com/blog/2020-03-30-dolt-use-cases/  
Dolt is Git for data. Instead of versioning files, Dolt versions tables. DoltHub is a place on the internet to share Dolt repositories. As far as we can tell, Dolt is the only database with branches. How would you use such a thing?

## 设计

**Visual Design Language: The Building Blocks Of Design**  
https://www.smashingmagazine.com/2020/03/visual-design-language-building-blocks/  
A robust visual design language is the cornerstone of good design. Here’s how the team at Fantasy approached designing a mobile OS for Huawei.

**The 10 best UX laws and principles**  
https://uxplanet.org/the-10-best-ux-laws-and-principles-7980ff22e424  
There are many User Experience principles and laws that a Designer should always look to follow. In this article, we’ve chosen a handful that we believe are the most important, and that we personally look to implement regularly. These laws and principles have not just been written by user advocates and Designers like Jakob Nielsen and Don Norman, but also by Psychologists who have years of experience studying human interaction and behaviour.
 
**Creating Etsy’s Design Principles**  
https://blog.marvelapp.com/creating-etsys-design-principles/  
Aligning on a shared definition of design excellence.

**Building dark mode on Stack Overflow**  
https://stackoverflow.blog/2020/03/31/building-dark-mode-on-stack-overflow/  
On March 30, 2020, we enabled folks to opt into a beta dark mode on Stack Overflow. Let’s talk about the work that went into it.

## 产品及其它

**RSS Stuff**  
https://css-tricks.com/rss-stuff/  
https://laurakalbag.com/how-to-read-rss-in-2020/  
Sometimes the content is just an excerpt, encouraging you to read the rest of the content on the original site. I think this defeats the point of providing RSS, where a big benefit is that the reader can customise how the posts display in their feed reader to improve their reading experience. 

**45 岁的微软，放下执念后，他跨越了时代**  
https://mp.weixin.qq.com/s/MzgDQcsQE_pRXvbvoLtWGw  
如何不被自己的当年成功的旧基因杀死，微软做了个新榜样。45 年来，从比尔·盖茨「让每一张桌子上，每一个家庭里都有一台个人电脑」到萨提亚·纳德拉的「助力每一个人和组织，成就不凡」，微软成功的放下了执念，也改变了自己，进而跨越了时代。现在他不再高呼「Windows 就是一切」，他有自己的阵地，也有自己的边界，他似乎更愿意藏在背后，赋能其他「酷公司」，与其他年轻公司成为伙伴。

**司徒君，一路走好🙏**  
https://www.zhihu.com/question/384157840  
https://mp.weixin.qq.com/s/MYgMg_jCEnQkQxUn3LI7Nw  
工作是一场长跑，人生更是。可持续发展，对码农尤为重要。今年偶然发现一个非常适合码农这个群体练习的功夫：张至顺道长的金刚养生功 https://www.bilibili.com/video/BV1T7411i78T 。简单易学，在家就能练，不仅能强身健体，还有助于调整心态。

> 对数据可视化有兴趣的可以阅读由 AntV 带来的 [墨者修齐 2020-04-06 · 如何创建安全的密码、Pajek 大型网络可视化工具、全球化的始于中国轮船](https://www.yuque.com/mo-college/weekly/ettpqr)
