---
layout: post
title: 'FEX 技术周刊 - 2018/12/03'
author: zhangjunah
tag: weekly
---

## 深阅读

**React 16.x Roadmap**  
https://reactjs.org/blog/2018/11/27/react-16-roadmap.html  
We plan to split the rollout of new React features into the following milestones:  
- React 16.6 with Suspense for Code Splitting (already shipped)
- A minor 16.x release with React Hooks (~Q1 2019)
- A minor 16.x release with Concurrent Mode (~Q2 2019)
- A minor 16.x release with Suspense for Data Fetching (~mid 2019)  
另附：[Under the hood of React’s hooks system](https://medium.com/the-guild/under-the-hood-of-reacts-hooks-system-eb59638c9dba)、[React Hooks Heading Towards an Official Release](https://github.com/reactjs/rfcs/pull/68#issuecomment-440780509)、[State of React State Management in 2019](https://blog.bitsrc.io/state-of-react-state-management-in-2019-779647206bbc).

**Backdoor in event-stream library dependency**  
https://github.com/dominictarr/event-stream/issues/116  
A malicious developer gained access to a popular npm module and added code that could steal cryptocurrency information. 附：[Details about the event-stream incident](https://blog.npmjs.org/post/180565383195/details-about-the-event-stream-incident)、[event-stream vulnerability explained](https://schneid.io/blog/event-stream-vulnerability-explained/)、[event-stream's Creator's Statement](https://gist.github.com/dominictarr/9fd9c1024c94592bc7268d36b8d83b3a).

**Project Guidelines**  
https://github.com/elsewhencode/project-guidelines  
While developing a new project is like rolling on a green field for you, maintaining it is a potential dark twisted nightmare for someone else. Here's a list of guidelines we've found, written and gathered that (we think) works really well with most JavaScript projects here at elsewhen. 另附：[The Front-End Checklist](https://frontendchecklist.io/)、[A free guide to `<head>` elements](https://gethead.info/).

**An Extensive Guide To Progressive Web Applications**  
https://www.smashingmagazine.com/2018/11/guide-pwa-progressive-web-applications/  
In this article, we’ll look at the pain points of users who are browsing old non-PWA websites and the promise of PWAs to make the web great. You’ll learn most of the important technologies that make for cool PWAs, like service workers, web push notifications and IndexedDB.

**Ionic Appflow: DevOps for Everyone**  
https://blog.ionicframework.com/ionic-appflow-devops-for-everyone/  
Put simply, Appflow is a DevOps solution for businesses building apps with Ionic. It helps teams increase agility, app quality, and time-to-market by automating key phases of the development lifecycle. 另附：[Announcing Ionic Studio: A Powerful New Way to Build Apps](https://blog.ionicframework.com/announcing-ionic-studio-a-powerful-new-way-to-build-apps/).

**W3C Web中文兴趣组启动会 - 总结报告**  
https://www.w3.org/2018/11/17-chinese-web-meeting-summary.html  
围绕 WebXR、Web Packaging、Media、下一代移动Web应用、WebGPU、Web Neural Network API、WebAssembly、Web性能、WebRTC、Web Payments 展开，探讨了以上技术目前的标准进展及应用情况、在国内是否有类似技术或实践、落地的可能性和面临的问题、以及国内是否有需求需要输送至 W3C 进而开展进一步讨论和后续工作。

**Taro深度开发实践**  
https://aotu.io/notes/2018/11/30/taro_practice/index.html  
Taro 是遵循 React 语法规范的多端开发方案，Taro 目前已经支持微信小程序、H5、RN、支付宝小程序、百度小程序，持续迭代中的 Taro，也正在兼容更多的端以及增加一些新特性的支持。本篇文章主要讲的是 Taro 深度开发实践，综合我们在实际项目中使用 Taro 的一些经验和总结，首先会谈谈 Taro 为什么选择使用React语法，然后再从Taro项目的代码组织、数据状态管理、性能优化以及多端兼容等几个方面来阐述 Taro 的深度开发实践体验。

**议 Function Component 与 Hooks**  
http://taobaofed.org/blog/2018/11/27/hooks-and-function-component/  
复杂应用尽可能使用 Function Component + Hooks 是值得推荐的，这是更美好的明天。另附：[像呼吸一样自然：React Hooks + RxJS](https://mp.weixin.qq.com/s/KNu0YUXyuZPoSz0Tn9mqpg)

**Hacking CSS writing mode**  
http://www.tipue.com/blog/css-writing-mode/  
The writing-mode CSS property sets horizontal and vertical text direction. While meant for multilingual purposes, it can be exploited for design.

**What, exactly, is the DOM?**  
https://bitsofco.de/what-exactly-is-the-dom/  
The Document Object Model, or the “DOM”, is an interface to web pages. It is essentially an API to the page, allowing programs to read and manipulate the page’s content, structure, and styles. Let’s break this down. 另附：[A look at CSS Resets in 2018](https://bitsofco.de/a-look-at-css-resets-in-2018/).

**The Art of Mathematics: A Mandala Maker Tutorial**  
https://24ways.org/2018/the-art-of-mathematics/  
In front-end development, there’s often a great deal of focus on tools that aim to make our work more efficient. But what if you’re new to web development? When you’re just starting out, the amount of new material can be overwhelming, particularly if you don’t have a solid background in Computer Science. But the truth is, once you’ve learned a little bit of JavaScript, you can already make some pretty impressive things.

**The subtle art of code golf in Javascript**  
https://www.lesscake.com/code-golf-javascript  
The goal of "code golf" is to reduce the size of a program as much as possible. It's a fascinating practice that I knew very little about. To change that, I recently challenged myself to code golf a simple Javascript program. In this article I'm sharing the program I wrote, and the 5 main stages I went through to make it much shorter. This should give an overview of the main techniques used to code golf in Javascript.

**HTTP_3 Explained**  
https://daniel.haxx.se/blog/2018/11/26/http3-explained/  
The book describes what HTTP/3 and its underlying transport protocol QUIC are, why they exist, what features they have and how they work. The book is meant to be readable and understandable for most people with a rudimentary level of network knowledge or better.

**5 Lessons Learned From Writing Over 300,000 Lines of Infrastructure Code**  
https://blog.gruntwork.io/5-lessons-learned-from-writing-over-300-000-lines-of-infrastructure-code-36ba7fadeac1  
A concise masterclass on how to write infrastructure code.

**Reliable Webhooks Using Serverless Architecture**  
https://medium.com/square-corner-blog/reliable-webhooks-using-serverless-architecture-e009a2096732  
How we made our webhooks more reliable using SQS and Lambda.

**How to balance full-time work with creative projects**  
https://thecreativeindependent.com/guides/how-to-balance-full-time-work-with-creative-projects/  
A guide to finding the right day job, protecting your time, and building creative habits by Jeffrey Silverstein, with illustrations by Sunny Eckerle.

**Is there a better way to document complex software architectures?**  
https://news.ycombinator.com/item?id=18508284  
So much craft has been put into better languages, better compilers, and better IDEs for the software developer, I'm absolutely confused - where is the modern 'IDE' for the Software Architect?

**Go 2, here we come!**  
https://blog.golang.org/go2-here-we-come  
A major difference between Go 1 and Go 2 is who is going to influence the design and how decisions are made. Go 1 was a small team effort with modest outside influence; Go 2 will be much more community-driven. After almost 10 years of exposure, we have learned a lot about the language and libraries that we didn’t know in the beginning, and that was only possible through feedback from the Go community. 另附：[知乎社区核心业务 Golang 化实践](https://zhuanlan.zhihu.com/p/48039838)。

## 新鲜货

**Announcing TypeScript 3.2**  
https://blogs.msdn.microsoft.com/typescript/2018/11/29/announcing-typescript-3-2/  
Below we have a bit about what’s new in 3.2: strictBindCallApply, Object spread on generic types, Object rest on generic types ,Node.js-based resolution for tsconfig.json inheritance...

**Announcing FoundationDB Document Layer**  
https://www.foundationdb.org/blog/announcing-document-layer/  
We’re open sourcing the FoundationDB Document Layer, a document-oriented database that extends the core functionality of the FoundationDB key-value store. The FoundationDB Document Layer provides the ease-of-use of a document database in the form of the familiar MongoDB® API. The Document Layer is a stateless server, backed by the scalable and transactional features of FoundationDB.

**Mozilla Funds Research Grants in Four Areas**  
https://blog.mozilla.org/blog/2018/11/28/mozilla-funds-research-grants-in-four-areas/  
In this tightly focused round, we awarded grants to support research in four areas: Web of the Things, Core Web Technologies, Voice/Language/Speech, and Mixed Reality. These projects support Mozilla’s mission to ensure the Internet is a global public resource, open and accessible to all. 另附：[The State of Mozilla - 2017 Annual Report](https://www.mozilla.org/en-US/foundation/annualreport/2017/).

**Call to Action: Accelerating Node.js Growth**  
https://medium.com/@nodejs/call-to-action-accelerating-node-js-growth-e4862bee2919  
Come join the new package maintenance team at https://github.com/nodejs/package-maintenance either to help out or to share your experience. I’ll talk in more detail about the initial work that this team will focus on, but first let’s introduce the challenge.

**SASS - Request For Comments: Module System**  
http://sass.logdown.com/posts/502818-request-for-comments-module-system-proposal  
Because of these problems and others, we've wanted to do a full overhaul of the way Sass files relate to one another for a long time. Over the last few years, I've been working with the Sass core team and Sass framework maintainers to create a proposal for a module system that's fit to replace @import. That proposal is now in a place that the core team is pretty happy with, at least as a starting point, so we want to open it up for community feedback.

**End-of-Life for Built-in JSDoc Support in ESLint**  
https://eslint.org/blog/2018/11/jsdoc-end-of-life  
As part of a recent review, we’ve decided to end-of-life the built-in support for JSDoc in the ESLint project. This post contains the details of that decision and what happens next. End-of-life for core JSDoc support means you will see the following happening in the next several weeks: Doctrine will no longer be updated; The require-jsdoc and valid-jsdoc rules will be deprecated; The SourceCode#getJSDocComment() method will be deprecated.

**Omi 5.0 release**  
https://github.com/Tencent/omi/releases/tag/v5.0.5  
Omi: Next Generation Web Framework in 4kb JavaScript. Merge JSX, Web Components, Proxy, Store, Path Updating together. 

**React Kawaii**  
https://github.com/miukimiu/react-kawaii  
React Kawaii is a library of cute SVG illustrations (react components). Ideal if you want to give some cuteness and personality to your react application.

**Sortable**  
https://github.com/rubaxa/Sortable  
Sortable — is a JavaScript library for reorderable drag-and-drop lists on modern browsers and touch devices. No jQuery. Supports Meteor, AngularJS, React, Polymer, Knockout and any CSS library, e.g. Bootstrap. 

**Cytoscape.js**  
http://js.cytoscape.org/  
Graph theory / network library for analysis and visualisation.

**PALX - Automatic UI Color Palette Generator**  
https://palx.jxnblk.com/  
Provide a single color value and Palx returns a full-spectrum color palette, well suited for UI design and data visualizations that work harmoniously with brand colors.

**NES.css: 8-bit style CSS framework**  
https://bcrikko.github.io/NES.css/  

**ncc: Node.js Compiler Collection**  
https://zeit.co/blog/ncc  
We are thrilled to introduce ncc, a simple Node.js CLI program and API for compiling Node.js projects into a single JavaScript file.
Inspired by native compiler toolchains, such as go, that export a static ELF binary file, ncc will output a self-contained script that bundles all its dependencies by leveraging webpack.

**Dust3D - Making 3D Model Has Never Been So Easy**  
https://dust3d.org/  
Dust3D is a cross-platform open-source modeling software. It helps you create a 3D watertight model in seconds. Use it to speed up your character modeling in game making, 3D printing, and so on.

**dive**  
https://github.com/wagoodman/dive  
A tool for exploring a docker image, layer contents, and discovering ways to shrink your Docker image size.

**10 Node Frameworks to Use in 2019**  
https://scotch.io/bar-talk/10-node-frameworks-to-use-in-2019  
Over the years, a lot of experienced JavaScript developers have built quite a number of impressive frameworks to easily get started with Node.js when developing web applications. As we look into 2019, I will list some of the most popular Node.js frameworks that you should consider using for building web applications irrespective of the size. 另附：[Comparing HTTP Request Libraries for 2019](https://blog.bitsrc.io/comparing-http-request-libraries-for-2019-7bedb1089c83)、[The Baseline Costs of JavaScript Frameworks](https://blog.uncommon.is/the-baseline-costs-of-javascript-frameworks-f768e2865d4a).

**Practical Elm book**  
https://korban.net/posts/elm/2018-11-28-practical-elm-019-update-published/  
I've published the Elm 0.19 update of my book, [Practical Elm for a Busy Developer](https://korban.net/posts/elm/2018-11-28-practical-elm-019-update-published/). This update is also based on the latest versions of elm-ui and elm-test packages.

**Open Source Awards**  
https://osawards.com/  
Most of Software developed around the world is based of Open Source projects. The culture of sharing and transperancy been always the main driver in the modern tech community. To celebrate annual achievements, and drive this culture forward, GitNation dedicates it's focus on supporting new and exciting Open Source projects on annual ceremonies.

## 设计

**Meet the new icons for Office 365**  
https://www.youtube.com/watch?time_continue=41&v=YplAU5myNP4  
As Design becomes the heart and soul of Office, we’ve evolved our visual identity to reflect the simple, powerful, and intelligent experiences of Office 365.

**The Role of Color in UX**  
https://www.toptal.com/designers/ux/color-in-ux  
Understanding color psychology is a key aspect of creating a color palette that works well in digital design. While color is sometimes thought of as a purely aesthetic choice by some designers, it is, in fact, a key component of the psychological impact of a design on users, and as such, its UX. 另附：[Understanding color psychology though culture, symbolism, and emotion](https://uxplanet.org/understanding-color-psychology-though-culture-symbolism-and-emotion-215102347276).

**When Motion Creates Emotion**  
https://blog.marvelapp.com/motion-creates-emotion/  
When people interact with digital products, they appreciate the value of humane products over purely rational products. Designers need to say goodbye to static user interfaces and create interfaces which will be much more alive.

**Why Your UX Design Really Failed**  
https://blog.prototypr.io/why-your-ux-design-really-failed-6e05c439996f  
There are eight primary areas where I see organizational behavior factor into a failed design process — leadership, teams, culture, organizational structure, knowledge management, managing uncertainty, competing goals and too much emphasis on process.

**“The world’s gone flat!” — evolutions in user interface design**  
https://uxdesign.cc/the-worlds-gone-flat-evolutions-in-interface-design-cb7ddd295f54  
In today’s context, flat design has hit its peak in terms of its ubiquity in interface design and designers have already started experimenting with how visuals can be made more appealing beyond sticking to just minimalism. Microsoft’s Fluent Design system is one example of a large tech company taking the lead in the next step of interface design. It combines what we love and what was helpful from skeuomorphic design with elements from minimalism.

## 产品及其它

**Does your Business Really Need a Mobile App?**  
https://blog.risingstack.com/does-your-business-really-need-a-mobile-app/  
Native mobile apps that focus only on one feature were okay, but they’re starting to become a thing of the past. Several new trends are going to make them obsolete: PWAs, superapps, chatbots and voice assistants. Creating a PWA is a great alternative for a general purpose application, and chatbots or voice assistants are very good for services like Uber or Lyft, but may not be suitable for everyone. The whole change-over is already happening, so maybe it’s time for mobile developers to add other technologies to their stack so that they can survive.

**[译]想当研究科学家，一事无成你受得了吗**  
https://mp.weixin.qq.com/s?__biz=MzA3MzI4MjgzMw==&mid=2650752922&idx=1&sn=a54fa6547dc395a237b9b3186c2cc649  
AI 研究科学家不是那么好当的！近日谷歌 AI 首席科学家 Vincent Vanhoucke 发表在 Medium 上的文章引来众人关注。在本文中，他列举了成为研究科学家所要面对的 9 大挑战，看完这篇内容或许可以在立志投身于科学事业前，给你先「泼一盆冷水」。

**比超级人类更可怕的，是宇宙的结局-霍金重磅遗作**  
https://mp.weixin.qq.com/s?__biz=MzUyMDQ5NzI5Mg==&mid=2247500714&idx=1&sn=fb643b269d05cd7112bb2819aad260f9  
在最近发售的重磅遗作《终极问答》一书中，霍金就探讨了基因技术对人类可能造成的深远影响，人类本世纪就能发现通过改造基因提高智力的技术，富人有朝一日会改造他们自己和后代的基因，让自己和孩子变成拥有更强记忆力、抗病力、智力和更长寿命的“超级人类”凌驾常人，甚至使后者灭绝。不过，除了“超级人类”，霍金一共在书里提出了10大终极问题，其中关于“宇宙”的思考，最是深邃。

**从濒临破产到起死回生：一本值得所有企业学习的生死书**  
https://www.huxiu.com/article/274388.html  
那些所谓靠大数据打磨《纸牌屋》的传说，可能也只是一部传说。事实没那么酷，只有残酷。真实的Netflix，其一路走来的经历，比你想象中更充满现实磨难与挑战。另附：[这份价值上亿的创业教训，有人为你买单了](https://www.huxiu.com/article/274407.html)、[追忆《华为基本法》](https://www.huxiu.com/article/274259.html)。

**爱拼不一定赢，背后的认知格局才是关键**  
https://mp.weixin.qq.com/s?__biz=MzUyMDQ5NzI5Mg==&mid=2247500809&idx=1&sn=e879189d5eabf7a41b1121dba586b435  
如果你看到每个热点都热血，跃跃欲试想要站立于风口；如果你越做越多，却发现各条线上都遭遇对手狙击；如果你已经把产品、运营都做到了极致，市场表现却差强人意，那么，你可以停一下，看看傅盛这篇讲战略的文章。战略，不是拼尽力气把竞争对手逼死，把自己忙晕，而是你对行业有没有超出对手的、与众不同的认知。这种认知格局决定了一个事业的开局，也决定了其破局和终局。

-- THE END --
